searchData={"content_type":"text/markdown","items":[{"doc":"Install SaladUI components and assets with customizable module prefix and color scheme.","ref":"Mix.Tasks.Salad.Install.html","title":"mix salad.install","type":"task"},{"doc":"mix salad.install\n    mix salad.install --prefix MyUIWeb.Components.UI\n    mix salad.install --color-scheme slate\n    mix salad.install --prefix CustomComponents --color-scheme blue","ref":"Mix.Tasks.Salad.Install.html#module-usage","title":"Usage - mix salad.install","type":"task"},{"doc":"Set up SaladUI in a Phoenix LiveView project.\n\nThis task configures the complete SaladUI development environment by:\n\n* Adding TwMerge.Cache to the application supervision tree\n* Configuring CSS color scheme variables (default: gray)\n* Copying SaladUI CSS files to assets/css/\n* Patching Tailwind CSS configuration with SaladUI-specific settings\n* Installing tailwindcss-animate plugin\n* Setting up JavaScript imports and LiveView hooks","ref":"Mix.Tasks.Salad.Setup.html","title":"mix salad.setup","type":"task"},{"doc":"mix salad.setup\n    mix salad.setup --color-scheme slate\n    mix salad.setup -c blue","ref":"Mix.Tasks.Salad.Setup.html#module-usage","title":"Usage - mix salad.setup","type":"task"},{"doc":"* `--color-scheme` (or `-c`) - Color scheme to use (default: \"gray\")\n    Available schemes: gray, slate, stone, neutral, red, orange, amber,\n    yellow, lime, green, emerald, teal, cyan, sky, blue, indigo, violet,\n    purple, fuchsia, pink, rose","ref":"Mix.Tasks.Salad.Setup.html#module-options","title":"Options - mix salad.setup","type":"task"},{"doc":"1. **TwMerge Integration** - Adds TwMerge.Cache as a supervised process for\n   CSS class merging functionality\n\n2. **CSS Setup**\n   - Copies salad_ui.css to assets/css/\n   - Adds color scheme variables to app.css\n   - Imports SaladUI styles into the main CSS file\n\n3. **Tailwind Configuration**\n   - Patches tailwind.config.js with SaladUI-specific plugins\n   - Copies tailwind.colors.json with design tokens\n   - Adds @tailwindcss/typography and tailwindcss-animate plugins\n\n4. **JavaScript Setup**\n   - Downloads and installs tailwindcss-animate\n   - Patches app.js to import SaladUI components and hooks\n   - Registers SaladUIHook with LiveView","ref":"Mix.Tasks.Salad.Setup.html#module-what-it-does","title":"What it does - mix salad.setup","type":"task"},{"doc":"You can immediately start using SaladUI components in your templates:\n\n    <.button>Click me</.button>\n    <.dialog id=\"my-dialog\">\n      <.dialog_content>\n         Hello world! \n      </.dialog_content>\n    </.dialog>","ref":"Mix.Tasks.Salad.Setup.html#module-after-running-this-task","title":"After running this task - mix salad.setup","type":"task"},{"doc":"* `lib/[app]/application.ex` - Adds TwMerge.Cache\n* `assets/css/app.css` - Adds color scheme and imports\n* `assets/css/salad_ui.css` - Created\n* `assets/tailwind.config.js` - Updated with plugins and content paths\n* `assets/tailwind.colors.json` - Created\n* `assets/js/app.js` - Adds SaladUI imports and hooks\n* `assets/vendor/tailwindcss-animate.js` - Downloaded","ref":"Mix.Tasks.Salad.Setup.html#module-files-modified","title":"Files modified - mix salad.setup","type":"task"},{"doc":"# Use default gray color scheme\n    mix salad.setup\n\n    # Use slate color scheme\n    mix salad.setup --color-scheme slate\n\n    # Short form\n    mix salad.setup -c blue","ref":"Mix.Tasks.Salad.Setup.html#module-example","title":"Example - mix salad.setup","type":"task"},{"doc":"SaladUI - A comprehensive UI component library for Phoenix LiveView applications.\n\nSaladUI provides a collection of accessible, customizable UI components that combine\nserver-side rendering with client-side interactivity. Built specifically for Phoenix\nLiveView, it offers seamless integration between Elixir and JavaScript.","ref":"SaladUI.html","title":"SaladUI","type":"module"},{"doc":"- **40+ UI Components** - Buttons, forms, overlays, navigation, and data display\n- **Accessibility First** - ARIA compliant with keyboard navigation and screen reader support\n- **LiveView Integration** - Two-way communication between server and client\n- **Customizable** - Tailwind CSS based with variant support\n- **Type Safe** - Full attribute validation and documentation","ref":"SaladUI.html#module-features","title":"Features - SaladUI","type":"module"},{"doc":"Add SaladUI to your Phoenix application:\n\n    # In your core components module\n    use SaladUI\n\n    # In templates\n    <.button variant=\"primary\" phx-click=\"save\">\n      Save Changes\n    </.button>","ref":"SaladUI.html#module-quick-start","title":"Quick Start - SaladUI","type":"module"},{"doc":"","ref":"SaladUI.html#module-component-categories","title":"Component Categories - SaladUI","type":"module"},{"doc":"- `card/1` - Content containers with headers and footers\n- `separator/1` - Visual dividers between content sections\n- `scroll_area/1` - Custom scrollable containers","ref":"SaladUI.html#module-layout-structure","title":"Layout & Structure - SaladUI","type":"module"},{"doc":"- `button/1` - Interactive buttons with multiple variants\n- `input/1` - Text inputs with validation support\n- `textarea/1` - Multi-line text input areas\n- `checkbox/1` - Binary choice inputs\n- `radio_group/1` - Single choice from multiple options\n- `select/1` - Dropdown selection menus\n- `slider/1` - Range value selection\n- `switch/1` - Toggle controls\n- `form/1`, `form_item/1`, `form_label/1` - Form structure and validation","ref":"SaladUI.html#module-forms-input","title":"Forms & Input - SaladUI","type":"module"},{"doc":"- `tabs/1` - Tabbed content navigation\n- `breadcrumb/1` - Hierarchical navigation paths\n- `pagination/1` - Page navigation controls\n- `sidebar/1` - Application navigation sidebars","ref":"SaladUI.html#module-navigation","title":"Navigation - SaladUI","type":"module"},{"doc":"- `dialog/1` - Modal dialogs and confirmations\n- `alert_dialog/1` - Alert and confirmation dialogs\n- `sheet/1` - Slide-out panels\n- `popover/1` - Contextual popup content\n- `tooltip/1` - Hover information displays\n- `hover_card/1` - Rich hover content\n- `dropdown_menu/1` - Contextual action menus","ref":"SaladUI.html#module-overlays-dialogs","title":"Overlays & Dialogs - SaladUI","type":"module"},{"doc":"- `alert/1` - Status messages and notifications\n- `badge/1` - Labels and status indicators\n- `progress/1` - Progress bars and loading states\n- `skeleton/1` - Loading placeholder content","ref":"SaladUI.html#module-feedback-status","title":"Feedback & Status - SaladUI","type":"module"},{"doc":"- `table/1` - Data tables with sorting and selection\n- `chart/1` - Data visualization charts\n- `avatar/1` - User profile images\n- `accordion/1` - Collapsible content sections","ref":"SaladUI.html#module-data-display","title":"Data Display - SaladUI","type":"module"},{"doc":"- `toggle/1`, `toggle_group/1` - Toggle controls and groups\n- `collapsible/1` - Expandable content areas\n- `command/1` - Command palette interfaces","ref":"SaladUI.html#module-utility","title":"Utility - SaladUI","type":"module"},{"doc":"SaladUI uses a hybrid architecture combining:\n\n- **Phoenix Function Components** - Server-side rendering with HEEx templates\n- **JavaScript State Machines** - Client-side behavior and interactivity\n- **LiveView Hooks** - Seamless server-client communication\n- **Automatic ARIA** - Accessibility attributes managed by the framework","ref":"SaladUI.html#module-architecture","title":"Architecture - SaladUI","type":"module"},{"doc":"","ref":"SaladUI.html#module-usage-patterns","title":"Usage Patterns - SaladUI","type":"module"},{"doc":"<.button variant=\"outline\" size=\"lg\">\n      Large Outline Button\n    </.button>","ref":"SaladUI.html#module-basic-component-usage","title":"Basic Component Usage - SaladUI","type":"module"},{"doc":"<.form for={@form} phx-change=\"validate\" phx-submit=\"save\">\n      <.form_item>\n        <.form_label>Email</.form_label>\n        <.form_control>\n          <.input field={@form[:email]} type=\"email\" />\n        </.form_control>\n        <.form_message field={@form[:email]} />\n      </.form_item>\n    </.form>","ref":"SaladUI.html#module-form-integration","title":"Form Integration - SaladUI","type":"module"},{"doc":"<.dialog id=\"user-dialog\" on-open={JS.push(\"dialog_opened\")}>\n      <.dialog_trigger>\n        <.button>Edit Profile</.button>\n      </.dialog_trigger>\n      <.dialog_content>\n        <!-- Dialog content -->\n      </.dialog_content>\n    </.dialog>","ref":"SaladUI.html#module-interactive-components-with-events","title":"Interactive Components with Events - SaladUI","type":"module"},{"doc":"# Send commands to components from LiveView\n    def handle_event(\"open_dialog\", _params, socket) do\n      socket = SaladUI.LiveView.send_command(socket, \"user-dialog\", \"open\")\n      {:noreply, socket}\n    end","ref":"SaladUI.html#module-server-client-communication","title":"Server-Client Communication - SaladUI","type":"module"},{"doc":"Components support extensive customization through:\n\n- **Variants** - Pre-defined style variations (e.g., `variant=\"destructive\"`)\n- **Classes** - Custom CSS classes via the `class` attribute\n- **Slots** - Flexible content areas within components\n- **Attributes** - Comprehensive configuration options","ref":"SaladUI.html#module-customization","title":"Customization - SaladUI","type":"module"},{"doc":"All components include:\n\n- Proper ARIA attributes and roles\n- Keyboard navigation support\n- Focus management for overlays\n- Screen reader announcements\n- High contrast support","ref":"SaladUI.html#module-accessibility","title":"Accessibility - SaladUI","type":"module"},{"doc":"When extending SaladUI:\n\n1. **Follow naming conventions** - Use `kebab-case` for data attributes\n2. **Implement state machines** - Define clear states and transitions\n3. **Handle accessibility** - Include ARIA configuration\n4. **Test thoroughly** - Verify keyboard and screen reader usage\n5. **Document examples** - Provide clear usage examples","ref":"SaladUI.html#module-development","title":"Development - SaladUI","type":"module"},{"doc":"When used, dispatch to the appropriate macro.","ref":"SaladUI.html#__using__/1","title":"SaladUI.__using__/1","type":"macro"},{"doc":"","ref":"SaladUI.html#component/0","title":"SaladUI.component/0","type":"function"},{"doc":"Implementation of the Accordion component.\n\nAccordions are vertically stacked sections that can be expanded/collapsed\nto reveal their content. They are useful for breaking down complex content\ninto digestible sections.","ref":"SaladUI.Accordion.html","title":"SaladUI.Accordion","type":"module"},{"doc":"<.accordion\n      id=\"faq-accordion\"\n      type=\"single\"\n      default-value=\"item-1\"\n      on-value-changed={JS.push(\"accordion_changed\")}\n    >\n      <.accordion_item value=\"item-1\">\n        <.accordion_trigger>\n          Is it accessible?\n        </.accordion_trigger>\n        <.accordion_content>\n          Yes. It adheres to the WAI-ARIA design pattern.\n        </.accordion_content>\n      </.accordion_item>\n      <.accordion_item value=\"item-2\">\n        <.accordion_trigger>\n          Is it styled?\n        </.accordion_trigger>\n        <.accordion_content>\n          Yes. It comes with default styles that matches the other components' aesthetic.\n        </.accordion_content>\n      </.accordion_item>\n    </.accordion>","ref":"SaladUI.Accordion.html#module-examples","title":"Examples: - SaladUI.Accordion","type":"module"},{"doc":"The main accordion component that manages the accordion state.","ref":"SaladUI.Accordion.html#accordion/1","title":"SaladUI.Accordion.accordion/1","type":"function"},{"doc":"* `:id` - Required unique identifier for the accordion.\n* `:type` - Type of accordion: \"single\" or \"multiple\". Defaults to \"single\".\n* `:value` - The currently expanded items. String for \"single\", list for \"multiple\".\n* `:default-value` - The default expanded items. Used if `:value` is not provided.\n* `:disabled` - Whether the accordion is disabled. Defaults to `false`.\n* `:on-value-changed` - Handler for accordion value change event.\n* `:class` - Additional CSS classes.","ref":"SaladUI.Accordion.html#accordion/1-options","title":"Options - SaladUI.Accordion.accordion/1","type":"function"},{"doc":"* `id` (`:string`) (required) - Unique identifier for the accordion.\n* `type` (`:string`) - Whether only one item can be open at a time. Defaults to `\"single\"`.\n* `value` (`:any`) - The value(s) of the currently expanded item(s). Defaults to `nil`.\n* `default-value` (`:any`) - The default value(s) of the expanded item(s). Defaults to `nil`.\n* `disabled` (`:boolean`) - Whether the accordion is disabled. Defaults to `false`.\n* `on-value-changed` (`:any`) - Handler for accordion value change event. Defaults to `nil`.\n* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Accordion.html#accordion/1-attributes","title":"Attributes - SaladUI.Accordion.accordion/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Accordion.html#accordion/1-slots","title":"Slots - SaladUI.Accordion.accordion/1","type":"function"},{"doc":"The content element of an accordion item that shows when expanded.","ref":"SaladUI.Accordion.html#accordion_content/1","title":"SaladUI.Accordion.accordion_content/1","type":"function"},{"doc":"* `:class` - Additional CSS classes.","ref":"SaladUI.Accordion.html#accordion_content/1-options","title":"Options - SaladUI.Accordion.accordion_content/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Accordion.html#accordion_content/1-attributes","title":"Attributes - SaladUI.Accordion.accordion_content/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Accordion.html#accordion_content/1-slots","title":"Slots - SaladUI.Accordion.accordion_content/1","type":"function"},{"doc":"An accordion item that contains a trigger and content.","ref":"SaladUI.Accordion.html#accordion_item/1","title":"SaladUI.Accordion.accordion_item/1","type":"function"},{"doc":"* `:value` - Required unique value for this accordion item.\n* `:disabled` - Whether this item is disabled. Defaults to `false`.\n* `:class` - Additional CSS classes.","ref":"SaladUI.Accordion.html#accordion_item/1-options","title":"Options - SaladUI.Accordion.accordion_item/1","type":"function"},{"doc":"* `value` (`:string`) (required) - Unique value for this accordion item.\n* `disabled` (`:boolean`) - Whether this item is disabled. Defaults to `false`.\n* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Accordion.html#accordion_item/1-attributes","title":"Attributes - SaladUI.Accordion.accordion_item/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Accordion.html#accordion_item/1-slots","title":"Slots - SaladUI.Accordion.accordion_item/1","type":"function"},{"doc":"The trigger element that expands/collapses an accordion item.","ref":"SaladUI.Accordion.html#accordion_trigger/1","title":"SaladUI.Accordion.accordion_trigger/1","type":"function"},{"doc":"* `:class` - Additional CSS classes.","ref":"SaladUI.Accordion.html#accordion_trigger/1-options","title":"Options - SaladUI.Accordion.accordion_trigger/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Accordion.html#accordion_trigger/1-attributes","title":"Attributes - SaladUI.Accordion.accordion_trigger/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Accordion.html#accordion_trigger/1-slots","title":"Slots - SaladUI.Accordion.accordion_trigger/1","type":"function"},{"doc":"Implementation of alert component for displaying important messages to users.\n\nAlerts are used to communicate status, warnings, or contextual feedback to users.\nThey can be configured with different variants to indicate severity and typically\nconsist of a title and a description.","ref":"SaladUI.Alert.html","title":"SaladUI.Alert","type":"module"},{"doc":"<.alert>\n      <.alert_title>Note</.alert_title>\n      <.alert_description>This is a standard informational alert.</.alert_description>\n    </.alert>\n\n    <.alert variant=\"destructive\">\n      <.alert_title>Error</.alert_title>\n      <.alert_description>\n        There was a problem with your request. Please try again.\n      </.alert_description>\n    </.alert>\n\n    <.alert>\n       \n         \n            \n         \n       \n      <.alert_title>Success</.alert_title>\n      <.alert_description>Your changes have been saved successfully.</.alert_description>\n    </.alert>","ref":"SaladUI.Alert.html#module-examples","title":"Examples: - SaladUI.Alert","type":"module"},{"doc":"Renders an alert container.\n\nThe alert component displays important messages or feedback to users with styling\nappropriate for the context.","ref":"SaladUI.Alert.html#alert/1","title":"SaladUI.Alert.alert/1","type":"function"},{"doc":"* `:variant` - The visual style of the alert. Available variants:\n  * `\"default\"` - Standard alert styling (default)\n  * `\"destructive\"` - Red-tinted styling for errors and warnings\n* `:class` - Additional CSS classes to apply to the alert container.","ref":"SaladUI.Alert.html#alert/1-options","title":"Options - SaladUI.Alert.alert/1","type":"function"},{"doc":"<.alert>\n      <.alert_title>Information</.alert_title>\n      <.alert_description>This is an informational message.</.alert_description>\n    </.alert>\n\n    <.alert variant=\"destructive\" class=\"mt-4\">\n      <.alert_title>Warning</.alert_title>\n      <.alert_description>This action cannot be undone.</.alert_description>\n    </.alert>","ref":"SaladUI.Alert.html#alert/1-examples","title":"Examples - SaladUI.Alert.alert/1","type":"function"},{"doc":"* `variant` (`:string`) - Defaults to `\"default\"`.\n* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Alert.html#alert/1-attributes","title":"Attributes - SaladUI.Alert.alert/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Alert.html#alert/1-slots","title":"Slots - SaladUI.Alert.alert/1","type":"function"},{"doc":"Renders an alert description.\n\nThe description provides more detailed information about the alert message.","ref":"SaladUI.Alert.html#alert_description/1","title":"SaladUI.Alert.alert_description/1","type":"function"},{"doc":"* `:class` - Additional CSS classes to apply to the description.","ref":"SaladUI.Alert.html#alert_description/1-options","title":"Options - SaladUI.Alert.alert_description/1","type":"function"},{"doc":"<.alert_description>Your account has been updated successfully.</.alert_description>\n    <.alert_description class=\"text-gray-600\">\n      Please review the changes before continuing.\n    </.alert_description>","ref":"SaladUI.Alert.html#alert_description/1-examples","title":"Examples - SaladUI.Alert.alert_description/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted. Supports all globals plus: `[\"disabled\", \"form\", \"name\", \"value\"]`.","ref":"SaladUI.Alert.html#alert_description/1-attributes","title":"Attributes - SaladUI.Alert.alert_description/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Alert.html#alert_description/1-slots","title":"Slots - SaladUI.Alert.alert_description/1","type":"function"},{"doc":"Renders an alert title.\n\nThe title component is used to provide a concise heading for the alert message.","ref":"SaladUI.Alert.html#alert_title/1","title":"SaladUI.Alert.alert_title/1","type":"function"},{"doc":"* `:class` - Additional CSS classes to apply to the title.","ref":"SaladUI.Alert.html#alert_title/1-options","title":"Options - SaladUI.Alert.alert_title/1","type":"function"},{"doc":"<.alert_title>Success</.alert_title>\n    <.alert_title class=\"text-primary\">Important Notice</.alert_title>","ref":"SaladUI.Alert.html#alert_title/1-examples","title":"Examples - SaladUI.Alert.alert_title/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted. Supports all globals plus: `[\"disabled\", \"form\", \"name\", \"value\"]`.","ref":"SaladUI.Alert.html#alert_title/1-attributes","title":"Attributes - SaladUI.Alert.alert_title/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Alert.html#alert_title/1-slots","title":"Slots - SaladUI.Alert.alert_title/1","type":"function"},{"doc":"Implementation of Alert Dialog component for SaladUI framework.\n\nAlert Dialogs are modal dialogs that require a user action before they can be dismissed,\nused to confirm user decisions or provide critical information.","ref":"SaladUI.AlertDialog.html","title":"SaladUI.AlertDialog","type":"module"},{"doc":"<.alert_dialog id=\"delete-confirmation\">\n      <.alert_dialog_trigger>\n        <.button variant=\"destructive\">Delete Account</.button>\n      </.alert_dialog_trigger>\n      <.alert_dialog_content>\n        <.alert_dialog_header>\n          <.alert_dialog_title>Are you absolutely sure?</.alert_dialog_title>\n          <.alert_dialog_description>\n            This action cannot be undone. This will permanently delete your\n            account and remove your data from our servers.\n          </.alert_dialog_description>\n        </.alert_dialog_header>\n        <.alert_dialog_footer>\n          <.alert_dialog_cancel>Cancel</.alert_dialog_cancel>\n          <.alert_dialog_action>Continue</.alert_dialog_action>\n        </.alert_dialog_footer>\n      </.alert_dialog_content>\n    </.alert_dialog>","ref":"SaladUI.AlertDialog.html#module-examples","title":"Examples: - SaladUI.AlertDialog","type":"module"},{"doc":"The main alert dialog component.","ref":"SaladUI.AlertDialog.html#alert_dialog/1","title":"SaladUI.AlertDialog.alert_dialog/1","type":"function"},{"doc":"* `:id` - Required unique identifier for the alert dialog.\n* `:open` - Whether the alert dialog is initially open. Defaults to `false`.\n* `:on-open` - Handler for alert dialog open event.\n* `:on-close` - Handler for alert dialog close event.\n* `:class` - Additional CSS classes.","ref":"SaladUI.AlertDialog.html#alert_dialog/1-options","title":"Options - SaladUI.AlertDialog.alert_dialog/1","type":"function"},{"doc":"* `id` (`:string`) (required) - Unique identifier for the alert dialog.\n* `open` (`:boolean`) - Whether the alert dialog is initially open. Defaults to `false`.\n* `on-open` (`:any`) - Handler for alert dialog open event. Defaults to `nil`.\n* `on-close` (`:any`) - Handler for alert dialog close event. Defaults to `nil`.\n* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.AlertDialog.html#alert_dialog/1-attributes","title":"Attributes - SaladUI.AlertDialog.alert_dialog/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.AlertDialog.html#alert_dialog/1-slots","title":"Slots - SaladUI.AlertDialog.alert_dialog/1","type":"function"},{"doc":"The primary action button for the alert dialog.","ref":"SaladUI.AlertDialog.html#alert_dialog_action/1","title":"SaladUI.AlertDialog.alert_dialog_action/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* `variant` (`:string`) - Defaults to `\"default\"`.\n* `size` (`:string`) - Defaults to `\"default\"`.\n* Global attributes are accepted.","ref":"SaladUI.AlertDialog.html#alert_dialog_action/1-attributes","title":"Attributes - SaladUI.AlertDialog.alert_dialog_action/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.AlertDialog.html#alert_dialog_action/1-slots","title":"Slots - SaladUI.AlertDialog.alert_dialog_action/1","type":"function"},{"doc":"The cancel button for the alert dialog.","ref":"SaladUI.AlertDialog.html#alert_dialog_cancel/1","title":"SaladUI.AlertDialog.alert_dialog_cancel/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* `variant` (`:string`) - Defaults to `\"outline\"`.\n* `size` (`:string`) - Defaults to `\"default\"`.\n* Global attributes are accepted.","ref":"SaladUI.AlertDialog.html#alert_dialog_cancel/1-attributes","title":"Attributes - SaladUI.AlertDialog.alert_dialog_cancel/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.AlertDialog.html#alert_dialog_cancel/1-slots","title":"Slots - SaladUI.AlertDialog.alert_dialog_cancel/1","type":"function"},{"doc":"The content container of the alert dialog.","ref":"SaladUI.AlertDialog.html#alert_dialog_content/1","title":"SaladUI.AlertDialog.alert_dialog_content/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.AlertDialog.html#alert_dialog_content/1-attributes","title":"Attributes - SaladUI.AlertDialog.alert_dialog_content/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.AlertDialog.html#alert_dialog_content/1-slots","title":"Slots - SaladUI.AlertDialog.alert_dialog_content/1","type":"function"},{"doc":"The description of the alert dialog.","ref":"SaladUI.AlertDialog.html#alert_dialog_description/1","title":"SaladUI.AlertDialog.alert_dialog_description/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.AlertDialog.html#alert_dialog_description/1-attributes","title":"Attributes - SaladUI.AlertDialog.alert_dialog_description/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.AlertDialog.html#alert_dialog_description/1-slots","title":"Slots - SaladUI.AlertDialog.alert_dialog_description/1","type":"function"},{"doc":"The footer section of the alert dialog containing action buttons.","ref":"SaladUI.AlertDialog.html#alert_dialog_footer/1","title":"SaladUI.AlertDialog.alert_dialog_footer/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.AlertDialog.html#alert_dialog_footer/1-attributes","title":"Attributes - SaladUI.AlertDialog.alert_dialog_footer/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.AlertDialog.html#alert_dialog_footer/1-slots","title":"Slots - SaladUI.AlertDialog.alert_dialog_footer/1","type":"function"},{"doc":"The header section of the alert dialog.","ref":"SaladUI.AlertDialog.html#alert_dialog_header/1","title":"SaladUI.AlertDialog.alert_dialog_header/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.AlertDialog.html#alert_dialog_header/1-attributes","title":"Attributes - SaladUI.AlertDialog.alert_dialog_header/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.AlertDialog.html#alert_dialog_header/1-slots","title":"Slots - SaladUI.AlertDialog.alert_dialog_header/1","type":"function"},{"doc":"The title of the alert dialog.","ref":"SaladUI.AlertDialog.html#alert_dialog_title/1","title":"SaladUI.AlertDialog.alert_dialog_title/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.AlertDialog.html#alert_dialog_title/1-attributes","title":"Attributes - SaladUI.AlertDialog.alert_dialog_title/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.AlertDialog.html#alert_dialog_title/1-slots","title":"Slots - SaladUI.AlertDialog.alert_dialog_title/1","type":"function"},{"doc":"The trigger element that opens the alert dialog.","ref":"SaladUI.AlertDialog.html#alert_dialog_trigger/1","title":"SaladUI.AlertDialog.alert_dialog_trigger/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* `as` (`:any`) - Defaults to `\"div\"`.\n* Global attributes are accepted.","ref":"SaladUI.AlertDialog.html#alert_dialog_trigger/1-attributes","title":"Attributes - SaladUI.AlertDialog.alert_dialog_trigger/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.AlertDialog.html#alert_dialog_trigger/1-slots","title":"Slots - SaladUI.AlertDialog.alert_dialog_trigger/1","type":"function"},{"doc":"Implementation of avatar component for user profile pictures with fallback support.\n\nAvatars are visual representations of users, typically displaying a profile picture\nor initials as a fallback. The component consists of a container, image, and fallback\nelements to ensure consistent display even when images fail to load.","ref":"SaladUI.Avatar.html","title":"SaladUI.Avatar","type":"module"},{"doc":"<.avatar>\n      <.avatar_image src=\"/images/profile.jpg\" alt=\"User avatar\" />\n      <.avatar_fallback>JD</.avatar_fallback>\n    </.avatar>\n\n    <.avatar class=\"h-12 w-12\">\n      <.avatar_image src={@user.avatar_url} alt={@user.name} />\n      <.avatar_fallback>\n         \n           \n         \n      </.avatar_fallback>\n    </.avatar>","ref":"SaladUI.Avatar.html#module-examples","title":"Examples: - SaladUI.Avatar","type":"module"},{"doc":"Renders an avatar container.\n\nThe avatar container is a wrapper that holds the avatar image and fallback content.","ref":"SaladUI.Avatar.html#avatar/1","title":"SaladUI.Avatar.avatar/1","type":"function"},{"doc":"* `:class` - Additional CSS classes to apply to the avatar container.","ref":"SaladUI.Avatar.html#avatar/1-options","title":"Options - SaladUI.Avatar.avatar/1","type":"function"},{"doc":"<.avatar>\n      <.avatar_image src=\"/images/profile.jpg\" alt=\"User avatar\" />\n      <.avatar_fallback>JD</.avatar_fallback>\n    </.avatar>\n\n    <.avatar class=\"h-16 w-16\">...</.avatar>","ref":"SaladUI.Avatar.html#avatar/1-examples","title":"Examples - SaladUI.Avatar.avatar/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Avatar.html#avatar/1-attributes","title":"Attributes - SaladUI.Avatar.avatar/1","type":"function"},{"doc":"* `inner_block`","ref":"SaladUI.Avatar.html#avatar/1-slots","title":"Slots - SaladUI.Avatar.avatar/1","type":"function"},{"doc":"Renders an avatar fallback element.\n\nThe fallback is displayed when the avatar image is not available or during image loading.\nThis can contain text (like user initials) or an icon.","ref":"SaladUI.Avatar.html#avatar_fallback/1","title":"SaladUI.Avatar.avatar_fallback/1","type":"function"},{"doc":"* `:class` - Additional CSS classes to apply to the fallback element.","ref":"SaladUI.Avatar.html#avatar_fallback/1-options","title":"Options - SaladUI.Avatar.avatar_fallback/1","type":"function"},{"doc":"<.avatar_fallback>JD</.avatar_fallback>\n\n    <.avatar_fallback class=\"bg-primary text-primary-foreground\">\n       <!-- User icon SVG --> \n    </.avatar_fallback>","ref":"SaladUI.Avatar.html#avatar_fallback/1-examples","title":"Examples - SaladUI.Avatar.avatar_fallback/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Avatar.html#avatar_fallback/1-attributes","title":"Attributes - SaladUI.Avatar.avatar_fallback/1","type":"function"},{"doc":"* `inner_block`","ref":"SaladUI.Avatar.html#avatar_fallback/1-slots","title":"Slots - SaladUI.Avatar.avatar_fallback/1","type":"function"},{"doc":"Renders an avatar image.\n\nThe image is set to display only after it has loaded, preventing layout shifts\nand allowing the fallback to show during loading.","ref":"SaladUI.Avatar.html#avatar_image/1","title":"SaladUI.Avatar.avatar_image/1","type":"function"},{"doc":"* `:src` - The URL of the avatar image.\n* `:alt` - The alt text for the image for accessibility.\n* `:class` - Additional CSS classes to apply to the image.","ref":"SaladUI.Avatar.html#avatar_image/1-options","title":"Options - SaladUI.Avatar.avatar_image/1","type":"function"},{"doc":"<.avatar_image src=\"/images/profile.jpg\" alt=\"User profile\" />\n    <.avatar_image src={@user.avatar_url} alt={@user.name} class=\"border-2\" />","ref":"SaladUI.Avatar.html#avatar_image/1-examples","title":"Examples - SaladUI.Avatar.avatar_image/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted. Supports all globals plus: `[\"alt\", \"src\"]`.","ref":"SaladUI.Avatar.html#avatar_image/1-attributes","title":"Attributes - SaladUI.Avatar.avatar_image/1","type":"function"},{"doc":"Implementation of badge component for displaying short labels, statuses, or counts.\n\nBadges are small UI elements typically used to highlight status, categories, or counts\nin a compact format. They are designed to be visually distinct and draw attention to\nimportant information.","ref":"SaladUI.Badge.html","title":"SaladUI.Badge","type":"module"},{"doc":"<.badge>New</.badge>\n    <.badge variant=\"secondary\">Beta</.badge>\n    <.badge variant=\"destructive\">Error</.badge>\n    <.badge variant=\"outline\">Version 1.0</.badge>\n\n     \n      <.badge>Default</.badge>\n      <.badge variant=\"secondary\">Secondary</.badge>\n      <.badge variant=\"destructive\">Destructive</.badge>\n      <.badge variant=\"outline\">Outline</.badge>","ref":"SaladUI.Badge.html#module-examples","title":"Examples: - SaladUI.Badge","type":"module"},{"doc":"Renders a badge component.","ref":"SaladUI.Badge.html#badge/1","title":"SaladUI.Badge.badge/1","type":"function"},{"doc":"* `:class` - Additional CSS classes to apply to the badge.\n* `:variant` - The visual style of the badge. Available variants:\n  * `\"default\"` - Primary color with white text (default)\n  * `\"secondary\"` - Secondary color with contrasting text\n  * `\"destructive\"` - Typically red, for warning or error states\n  * `\"outline\"` - Bordered style with no background","ref":"SaladUI.Badge.html#badge/1-options","title":"Options - SaladUI.Badge.badge/1","type":"function"},{"doc":"<.badge>Badge</.badge>\n    <.badge variant=\"destructive\">Warning</.badge>\n    <.badge variant=\"outline\" class=\"text-sm\">Custom</.badge>","ref":"SaladUI.Badge.html#badge/1-examples","title":"Examples - SaladUI.Badge.badge/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* `variant` (`:string`) - the badge variant style. Defaults to `\"default\"`.\n* Global attributes are accepted.","ref":"SaladUI.Badge.html#badge/1-attributes","title":"Attributes - SaladUI.Badge.badge/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Badge.html#badge/1-slots","title":"Slots - SaladUI.Badge.badge/1","type":"function"},{"doc":"Implementation of breadcrumb component from https://ui.shadcn.com/docs/components/breadcrumb\n\nBreadcrumbs help users navigate through the application by showing the current location\nand providing links to previous levels in the hierarchy.","ref":"SaladUI.Breadcrumb.html","title":"SaladUI.Breadcrumb","type":"module"},{"doc":"* Semantic HTML structure with proper ARIA attributes for accessibility\n* Visual separators between navigation items\n* Current page indication with proper styling\n* Optional ellipsis for collapsed paths\n* Responsive design capabilities","ref":"SaladUI.Breadcrumb.html#module-features","title":"Features - SaladUI.Breadcrumb","type":"module"},{"doc":"<.breadcrumb>\n      <.breadcrumb_list>\n        <.breadcrumb_item>\n          <.breadcrumb_link href=\"/\">Home</.breadcrumb_link>\n        </.breadcrumb_item>\n        <.breadcrumb_separator />\n        <.breadcrumb_item>\n          <.breadcrumb_link href=\"/components\">Components</.breadcrumb_link>\n        </.breadcrumb_item>\n        <.breadcrumb_separator />\n        <.breadcrumb_item>\n          <.breadcrumb_page>Breadcrumb</.breadcrumb_page>\n        </.breadcrumb_item>\n      </.breadcrumb_list>\n    </.breadcrumb>\n\nFor responsive breadcrumbs that collapse on mobile:\n\n    <.breadcrumb>\n      <.breadcrumb_list>\n        <.breadcrumb_item>\n          <.breadcrumb_link href=\"/\">Home</.breadcrumb_link>\n        </.breadcrumb_item>\n        <.breadcrumb_separator />\n\n        <!-- Show on desktop only -->\n         \n          <.breadcrumb_item>\n            <.breadcrumb_link href=\"/components\">Components</.breadcrumb_link>\n          </.breadcrumb_item>\n          <.breadcrumb_separator />\n         \n\n        <!-- Show on mobile only -->\n         \n          <.breadcrumb_ellipsis />\n          <.breadcrumb_separator />\n         \n\n        <.breadcrumb_item>\n          <.breadcrumb_page>Breadcrumb</.breadcrumb_page>\n        </.breadcrumb_item>\n      </.breadcrumb_list>\n    </.breadcrumb>","ref":"SaladUI.Breadcrumb.html#module-examples","title":"Examples - SaladUI.Breadcrumb","type":"module"},{"doc":"Renders a breadcrumb.","ref":"SaladUI.Breadcrumb.html#breadcrumb/1","title":"SaladUI.Breadcrumb.breadcrumb/1","type":"function"},{"doc":"* `:class` - Additional CSS classes to apply to the breadcrumb container","ref":"SaladUI.Breadcrumb.html#breadcrumb/1-attributes","title":"Attributes - SaladUI.Breadcrumb.breadcrumb/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Breadcrumb.html#breadcrumb/1-attributes","title":"Attributes - SaladUI.Breadcrumb.breadcrumb/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Breadcrumb.html#breadcrumb/1-slots","title":"Slots - SaladUI.Breadcrumb.breadcrumb/1","type":"function"},{"doc":"Renders an ellipsis indicator for collapsed breadcrumb items.\n\nUsed in responsive designs to indicate that some breadcrumb items are hidden.\nTypically used for middle items in a long breadcrumb path on mobile views.","ref":"SaladUI.Breadcrumb.html#breadcrumb_ellipsis/1","title":"SaladUI.Breadcrumb.breadcrumb_ellipsis/1","type":"function"},{"doc":"* `:class` - Additional CSS classes to apply to the ellipsis","ref":"SaladUI.Breadcrumb.html#breadcrumb_ellipsis/1-attributes","title":"Attributes - SaladUI.Breadcrumb.breadcrumb_ellipsis/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Breadcrumb.html#breadcrumb_ellipsis/1-attributes","title":"Attributes - SaladUI.Breadcrumb.breadcrumb_ellipsis/1","type":"function"},{"doc":"Renders a breadcrumb item.\n\nIndividual item in the breadcrumb path that can contain a link or the current page.","ref":"SaladUI.Breadcrumb.html#breadcrumb_item/1","title":"SaladUI.Breadcrumb.breadcrumb_item/1","type":"function"},{"doc":"* `:class` - Additional CSS classes to apply to the item","ref":"SaladUI.Breadcrumb.html#breadcrumb_item/1-attributes","title":"Attributes - SaladUI.Breadcrumb.breadcrumb_item/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Breadcrumb.html#breadcrumb_item/1-attributes","title":"Attributes - SaladUI.Breadcrumb.breadcrumb_item/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Breadcrumb.html#breadcrumb_item/1-slots","title":"Slots - SaladUI.Breadcrumb.breadcrumb_item/1","type":"function"},{"doc":"Renders a breadcrumb link.\n\nUsed for all breadcrumb items except the current page.","ref":"SaladUI.Breadcrumb.html#breadcrumb_link/1","title":"SaladUI.Breadcrumb.breadcrumb_link/1","type":"function"},{"doc":"* `:class` - Additional CSS classes to apply to the link\n* Standard HTML link attributes (href, target, etc.) are supported","ref":"SaladUI.Breadcrumb.html#breadcrumb_link/1-attributes","title":"Attributes - SaladUI.Breadcrumb.breadcrumb_link/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted. Supports all globals plus: `[\"download\", \"href\", \"hreflang\", \"ping\", \"referrerpolicy\", \"rel\", \"target\", \"type\"]`.","ref":"SaladUI.Breadcrumb.html#breadcrumb_link/1-attributes","title":"Attributes - SaladUI.Breadcrumb.breadcrumb_link/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Breadcrumb.html#breadcrumb_link/1-slots","title":"Slots - SaladUI.Breadcrumb.breadcrumb_link/1","type":"function"},{"doc":"Renders breadcrumb list.\n\nWraps the breadcrumb items in an ordered list to represent the hierarchical structure.","ref":"SaladUI.Breadcrumb.html#breadcrumb_list/1","title":"SaladUI.Breadcrumb.breadcrumb_list/1","type":"function"},{"doc":"* `:class` - Additional CSS classes to apply to the list","ref":"SaladUI.Breadcrumb.html#breadcrumb_list/1-attributes","title":"Attributes - SaladUI.Breadcrumb.breadcrumb_list/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Breadcrumb.html#breadcrumb_list/1-attributes","title":"Attributes - SaladUI.Breadcrumb.breadcrumb_list/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Breadcrumb.html#breadcrumb_list/1-slots","title":"Slots - SaladUI.Breadcrumb.breadcrumb_list/1","type":"function"},{"doc":"Renders the current page breadcrumb item.\n\nUsed for the final item in the breadcrumb path, representing the current page.\nThe current page is not a link but styled differently to indicate the current location.","ref":"SaladUI.Breadcrumb.html#breadcrumb_page/1","title":"SaladUI.Breadcrumb.breadcrumb_page/1","type":"function"},{"doc":"* `:class` - Additional CSS classes to apply to the current page element","ref":"SaladUI.Breadcrumb.html#breadcrumb_page/1-attributes","title":"Attributes - SaladUI.Breadcrumb.breadcrumb_page/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Breadcrumb.html#breadcrumb_page/1-attributes","title":"Attributes - SaladUI.Breadcrumb.breadcrumb_page/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Breadcrumb.html#breadcrumb_page/1-slots","title":"Slots - SaladUI.Breadcrumb.breadcrumb_page/1","type":"function"},{"doc":"Renders a separator between breadcrumb items.\n\nVisual indicator that separates items in the breadcrumb path.\nBy default, shows a chevron right icon.","ref":"SaladUI.Breadcrumb.html#breadcrumb_separator/1","title":"SaladUI.Breadcrumb.breadcrumb_separator/1","type":"function"},{"doc":"* `:class` - Additional CSS classes to apply to the separator","ref":"SaladUI.Breadcrumb.html#breadcrumb_separator/1-attributes","title":"Attributes - SaladUI.Breadcrumb.breadcrumb_separator/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Breadcrumb.html#breadcrumb_separator/1-attributes","title":"Attributes - SaladUI.Breadcrumb.breadcrumb_separator/1","type":"function"},{"doc":"Button component for user interactions.\n\nProvides a versatile button component with various styles, sizes, and states\nto handle user interactions throughout the application.","ref":"SaladUI.Button.html","title":"SaladUI.Button","type":"module"},{"doc":"Renders a button with configurable styles and behaviors.","ref":"SaladUI.Button.html#button/1","title":"SaladUI.Button.button/1","type":"function"},{"doc":"* `:type` - HTML button type attribute (e.g., \"button\", \"submit\")\n* `:class` - Additional CSS classes\n* `:variant` - Visual style variant of the button:\n    * `\"default\"` - Primary action button\n    * `\"secondary\"` - Secondary action button\n    * `\"destructive\"` - Buttons for destructive actions\n    * `\"outline\"` - Button with outline style\n    * `\"ghost\"` - Button with minimal styling\n    * `\"link\"` - Button that appears as a link\n* `:size` - Size of the button:\n    * `\"default\"` - Standard size\n    * `\"sm\"` - Small size\n    * `\"lg\"` - Large size\n    * `\"icon\"` - Square button optimized for icons\n* `:rest` - Additional HTML attributes including `disabled`, `form`, `name`, `value`","ref":"SaladUI.Button.html#button/1-attributes","title":"Attributes - SaladUI.Button.button/1","type":"function"},{"doc":"<.button>Send</.button>\n    <.button variant=\"destructive\" phx-click=\"delete\">Delete</.button>\n    <.button variant=\"outline\" size=\"sm\">Cancel</.button>\n    <.button variant=\"ghost\" size=\"icon\">\n      <.icon name=\"hero-x-mark\" />\n    </.button>\n    <.button type=\"submit\" phx-disable-with=\"Saving...\">Save Changes</.button>","ref":"SaladUI.Button.html#button/1-examples","title":"Examples - SaladUI.Button.button/1","type":"function"},{"doc":"* `type` (`:string`) - Defaults to `nil`.\n* `class` (`:any`) - Defaults to `nil`.\n* `variant` (`:string`) - the button variant style. Defaults to `\"default\"`.\n* `size` (`:string`) - Defaults to `\"default\"`.\n* Global attributes are accepted. Supports all globals plus: `[\"disabled\", \"form\", \"name\", \"value\"]`.","ref":"SaladUI.Button.html#button/1-attributes","title":"Attributes - SaladUI.Button.button/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Button.html#button/1-slots","title":"Slots - SaladUI.Button.button/1","type":"function"},{"doc":"Card components for containing content and actions.\n\nCards provide a flexible container for displaying content with support for headers,\nfooters, and various content layouts. They organize information and actions consistently.","ref":"SaladUI.Card.html","title":"SaladUI.Card","type":"module"},{"doc":"Renders a card container.","ref":"SaladUI.Card.html#card/1","title":"SaladUI.Card.card/1","type":"function"},{"doc":"<.card>\n      <.card_header>\n        <.card_title>Account Settings</.card_title>\n        <.card_description>Manage your account settings.</.card_description>\n      </.card_header>\n      <.card_content>\n         Your account details and preferences. \n      </.card_content>\n      <.card_footer>\n        <.button variant=\"outline\">Cancel</.button>\n        <.button>Save</.button>\n      </.card_footer>\n    </.card>","ref":"SaladUI.Card.html#card/1-examples","title":"Examples: - SaladUI.Card.card/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Card.html#card/1-attributes","title":"Attributes - SaladUI.Card.card/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Card.html#card/1-slots","title":"Slots - SaladUI.Card.card/1","type":"function"},{"doc":"Renders the main content area of the card.","ref":"SaladUI.Card.html#card_content/1","title":"SaladUI.Card.card_content/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Card.html#card_content/1-attributes","title":"Attributes - SaladUI.Card.card_content/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Card.html#card_content/1-slots","title":"Slots - SaladUI.Card.card_content/1","type":"function"},{"doc":"Renders a card description within the header section.","ref":"SaladUI.Card.html#card_description/1","title":"SaladUI.Card.card_description/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Card.html#card_description/1-attributes","title":"Attributes - SaladUI.Card.card_description/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Card.html#card_description/1-slots","title":"Slots - SaladUI.Card.card_description/1","type":"function"},{"doc":"Renders a footer section for the card, typically containing actions.","ref":"SaladUI.Card.html#card_footer/1","title":"SaladUI.Card.card_footer/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Card.html#card_footer/1-attributes","title":"Attributes - SaladUI.Card.card_footer/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Card.html#card_footer/1-slots","title":"Slots - SaladUI.Card.card_footer/1","type":"function"},{"doc":"Renders a card header section for title and description.","ref":"SaladUI.Card.html#card_header/1","title":"SaladUI.Card.card_header/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Card.html#card_header/1-attributes","title":"Attributes - SaladUI.Card.card_header/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Card.html#card_header/1-slots","title":"Slots - SaladUI.Card.card_header/1","type":"function"},{"doc":"Renders a card title within the header section.","ref":"SaladUI.Card.html#card_title/1","title":"SaladUI.Card.card_title/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Card.html#card_title/1-attributes","title":"Attributes - SaladUI.Card.card_title/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Card.html#card_title/1-slots","title":"Slots - SaladUI.Card.card_title/1","type":"function"},{"doc":"Chart component.\n\nThis component displays a chart using a live component for real-time updates. Data and configuration are passed as attributes, and the rendering is managed on the client side through a hook called `ChartHook`. This hook initializes, manages the lifecycle, and renders the chart using a chart library. `SaladUI` comes with [Chart.js](https://www.chartjs.org/) as default, but you can rewrite `ChartHook` to integrate another chart library.","ref":"SaladUI.Chart.html","title":"SaladUI.Chart","type":"module"},{"doc":"The `chart_options` map defines the appearance and behavior of the chart:\n\n- Special keys\n  - `labels`: A list of labels for the x-axis\n  - `type`: Chart type (e.g., \"line\", \"bar\") - must match the chart library's supported types\n  - `options`: A map of chart options following the chart library's API\n\n- Dataset configuration:\n  Any additional keys in the options map define datasets. For example:\n\n  ```elixir\n  %{\n    labels: [\"Jan\", \"Feb\"],\n    type: \"line\",\n    options: %{responsive: true},\n    desktop: %{                    # Dataset configuration\n      label: \"Desktop Usage\",      # Chart.js dataset options\n      datakey: \"desktop_value\"     # Optional: custom key for data mapping\n    }\n  }\n  ```","ref":"SaladUI.Chart.html#module-chart-options","title":"Chart options - SaladUI.Chart","type":"module"},{"doc":"The `chart_data` must be a list of maps. Each map represents a data point:\n\n```elixir\n[\n  %{desktop: 10, mobile: 20},  # First data point\n  %{desktop: 15, mobile: 25}   # Second data point\n]\n```\n\nThe data could be in any shape and you can map a dataset from the chart configuration to a data point in the chart data using the `datakey` key.\n\nAll data points that do not match any datasets will be ignored.","ref":"SaladUI.Chart.html#module-chart-data","title":"Chart data - SaladUI.Chart","type":"module"},{"doc":"","ref":"SaladUI.Chart.html#chart/1","title":"SaladUI.Chart.chart/1","type":"function"},{"doc":"* `id` (`:string`) (required)\n* `name` (`:string`) - name of the chart for screen readers. Defaults to `\"\"`.\n* `chart-type` (`:string`) - type of the chart (e.g., line, bar). Defaults to `\"line\"`.\n* `chart-options` (`:map`) (required)\n* `chart-data` (`:list`) (required)","ref":"SaladUI.Chart.html#chart/1-attributes","title":"Attributes - SaladUI.Chart.chart/1","type":"function"},{"doc":"Implementation of checkbox component from https://ui.shadcn.com/docs/components/checkbox","ref":"SaladUI.Checkbox.html","title":"SaladUI.Checkbox","type":"module"},{"doc":"<.checkbox name=\"terms\" id=\"terms\" />\n\n     \n      <.checkbox id=\"terms\" name=\"terms\" />\n      <.label for=\"terms\">Accept terms and conditions</.label>\n     \n\n    <.checkbox id=\"remember_me\" name=\"remember_me\" label=\"Remember me\" />\n\n    <.form for={@form} as={:user} phx-change=\"validate\">\n      <.checkbox field={@form[:accept_terms]} label=\"I accept the terms and conditions\" />\n    </.form>","ref":"SaladUI.Checkbox.html#module-examples","title":"Examples: - SaladUI.Checkbox","type":"module"},{"doc":"Renders a checkbox input with SaladUI styling.","ref":"SaladUI.Checkbox.html#checkbox/1","title":"SaladUI.Checkbox.checkbox/1","type":"function"},{"doc":"* `:id` - The id to apply to the checkbox\n* `:name` - The name to apply to the input field\n* `:value` - The current value of the checkbox\n* `:default-value` - The default value of the checkbox, either `true`, `false`, \"true\", \"false\"\n* `:disabled` - Whether the checkbox is disabled\n* `:field` - A Phoenix form field\n* `:class` - Additional classes to add to the checkbox","ref":"SaladUI.Checkbox.html#checkbox/1-options","title":"Options - SaladUI.Checkbox.checkbox/1","type":"function"},{"doc":"* `name` (`:any`) - Defaults to `nil`.\n* `value` (`:any`) - Defaults to `nil`.\n* `default-value` (`:any`) - Defaults to `false`.\n* `field` (`Phoenix.HTML.FormField`)\n* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Checkbox.html#checkbox/1-attributes","title":"Attributes - SaladUI.Checkbox.checkbox/1","type":"function"},{"doc":"Implementation of Collapsible component for SaladUI framework.\n\nThis component allows content to be shown or hidden with smooth animations,\naccessibility support, and keyboard navigation.","ref":"SaladUI.Collapsible.html","title":"SaladUI.Collapsible","type":"module"},{"doc":"<.collapsible id=\"collapsible-1\" open>\n      <.collapsible_trigger>\n        <.button variant=\"outline\">Show content</.button>\n      </.collapsible_trigger>\n      <.collapsible_content>\n         \n          Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed do eiusmod tempor\n          incididunt ut labore et dolore magna aliqua.\n         \n      </.collapsible_content>\n    </.collapsible>","ref":"SaladUI.Collapsible.html#module-examples","title":"Examples: - SaladUI.Collapsible","type":"module"},{"doc":"The main collapsible component.","ref":"SaladUI.Collapsible.html#collapsible/1","title":"SaladUI.Collapsible.collapsible/1","type":"function"},{"doc":"* `:id` - Required unique identifier for the collapsible.\n* `:open` - Whether the collapsible is initially open. Defaults to `false`.\n* `:on-open` - Handler for collapsible open event.\n* `:on-close` - Handler for collapsible close event.\n* `:class` - Additional CSS classes.","ref":"SaladUI.Collapsible.html#collapsible/1-options","title":"Options - SaladUI.Collapsible.collapsible/1","type":"function"},{"doc":"* `id` (`:string`) (required) - Unique identifier for the collapsible.\n* `open` (`:boolean`) - Whether the collapsible is initially open. Defaults to `false`.\n* `on-open` (`:any`) - Handler for collapsible open event. Defaults to `nil`.\n* `on-close` (`:any`) - Handler for collapsible close event. Defaults to `nil`.\n* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Collapsible.html#collapsible/1-attributes","title":"Attributes - SaladUI.Collapsible.collapsible/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Collapsible.html#collapsible/1-slots","title":"Slots - SaladUI.Collapsible.collapsible/1","type":"function"},{"doc":"The collapsible content that appears when triggered.","ref":"SaladUI.Collapsible.html#collapsible_content/1","title":"SaladUI.Collapsible.collapsible_content/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Collapsible.html#collapsible_content/1-attributes","title":"Attributes - SaladUI.Collapsible.collapsible_content/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Collapsible.html#collapsible_content/1-slots","title":"Slots - SaladUI.Collapsible.collapsible_content/1","type":"function"},{"doc":"The trigger element that toggles the collapsible content.","ref":"SaladUI.Collapsible.html#collapsible_trigger/1","title":"SaladUI.Collapsible.collapsible_trigger/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* `as` (`:any`) - Defaults to `\"div\"`.\n* Global attributes are accepted.","ref":"SaladUI.Collapsible.html#collapsible_trigger/1-attributes","title":"Attributes - SaladUI.Collapsible.collapsible_trigger/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Collapsible.html#collapsible_trigger/1-slots","title":"Slots - SaladUI.Collapsible.collapsible_trigger/1","type":"function"},{"doc":"Command palette components for SaladUI.\n\nProvides a set of components to build a command palette or searchable menu, similar to those found in modern applications.","ref":"SaladUI.Command.html","title":"SaladUI.Command","type":"module"},{"doc":"<.command id=\"command\" class=\"rounded-lg border shadow-md md:min-w-[450px] w-full lg:max-w-[600px]\">\n      <.command_input placeholder=\"Type a command or search...\" />\n      <.command_empty>\n         No results found \n      </.command_empty>\n      <.command_list>\n        <.command_group heading=\"Suggestions\">\n          <.command_item phx-value-name=\"calendar\" phx-click=\"select_command\">\n            <.calendar class=\"w-4 h-4\"/>\n             Calendar \n          </.command_item>\n          ...\n        </.command_group>\n        <.command_group heading=\"Settings\">\n          <.command_item phx-value-name=\"profile\" phx-click=\"select_command\">\n            <.user class=\"w-4 h-4\"/>\n             Profile \n            <.command_shortcut>⌘P</.command_shortcut>\n          </.command_item>\n          ...\n        </.command_group>\n      </.command_list>\n    </.command>","ref":"SaladUI.Command.html#module-example","title":"Example - SaladUI.Command","type":"module"},{"doc":"Renders the root command palette container.","ref":"SaladUI.Command.html#command/1","title":"SaladUI.Command.command/1","type":"function"},{"doc":"* `:id` (required) - The unique id for the command palette.\n  * `:class` - Additional classes to apply.","ref":"SaladUI.Command.html#command/1-attributes","title":"Attributes - SaladUI.Command.command/1","type":"function"},{"doc":"* `:inner_block` (required) - The content of the command palette.","ref":"SaladUI.Command.html#command/1-slots","title":"Slots - SaladUI.Command.command/1","type":"function"},{"doc":"<.command id=\"my-command\">\n      ...\n    </.command>","ref":"SaladUI.Command.html#command/1-example","title":"Example - SaladUI.Command.command/1","type":"function"},{"doc":"* `id` (`:string`) (required)\n* `class` (`:any`) - Defaults to `\"\"`.","ref":"SaladUI.Command.html#command/1-attributes","title":"Attributes - SaladUI.Command.command/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Command.html#command/1-slots","title":"Slots - SaladUI.Command.command/1","type":"function"},{"doc":"Renders a command palette inside a dialog.","ref":"SaladUI.Command.html#command_dialog/1","title":"SaladUI.Command.command_dialog/1","type":"function"},{"doc":"* `:id` (required) - The unique id for the command palette.\n  * `:open` - Whether the dialog is open.","ref":"SaladUI.Command.html#command_dialog/1-attributes","title":"Attributes - SaladUI.Command.command_dialog/1","type":"function"},{"doc":"* `:inner_block` (required) - The content of the command palette.","ref":"SaladUI.Command.html#command_dialog/1-slots","title":"Slots - SaladUI.Command.command_dialog/1","type":"function"},{"doc":"<.command_dialog id=\"my-command\" open={@show_command}>\n      ...\n    </.command_dialog>","ref":"SaladUI.Command.html#command_dialog/1-example","title":"Example - SaladUI.Command.command_dialog/1","type":"function"},{"doc":"* `id` (`:string`) (required)\n* `open` (`:boolean`) - Defaults to `false`.","ref":"SaladUI.Command.html#command_dialog/1-attributes","title":"Attributes - SaladUI.Command.command_dialog/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Command.html#command_dialog/1-slots","title":"Slots - SaladUI.Command.command_dialog/1","type":"function"},{"doc":"Renders a message when no command results are found.","ref":"SaladUI.Command.html#command_empty/1","title":"SaladUI.Command.command_empty/1","type":"function"},{"doc":"* `:class` - Additional classes to apply.","ref":"SaladUI.Command.html#command_empty/1-attributes","title":"Attributes - SaladUI.Command.command_empty/1","type":"function"},{"doc":"* `:inner_block` (required) - The content to display when empty.","ref":"SaladUI.Command.html#command_empty/1-slots","title":"Slots - SaladUI.Command.command_empty/1","type":"function"},{"doc":"<.command_empty>\n       No results found \n    </.command_empty>","ref":"SaladUI.Command.html#command_empty/1-example","title":"Example - SaladUI.Command.command_empty/1","type":"function"},{"doc":"* `class` (`:any`) - Defaults to `\"\"`.","ref":"SaladUI.Command.html#command_empty/1-attributes","title":"Attributes - SaladUI.Command.command_empty/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Command.html#command_empty/1-slots","title":"Slots - SaladUI.Command.command_empty/1","type":"function"},{"doc":"Renders a group of command items with a heading.","ref":"SaladUI.Command.html#command_group/1","title":"SaladUI.Command.command_group/1","type":"function"},{"doc":"* `:heading` (required) - The group heading.","ref":"SaladUI.Command.html#command_group/1-attributes","title":"Attributes - SaladUI.Command.command_group/1","type":"function"},{"doc":"* `:inner_block` (required) - The command items in the group.","ref":"SaladUI.Command.html#command_group/1-slots","title":"Slots - SaladUI.Command.command_group/1","type":"function"},{"doc":"<.command_group heading=\"Settings\">\n      <.command_item>Profile</.command_item>\n    </.command_group>","ref":"SaladUI.Command.html#command_group/1-example","title":"Example - SaladUI.Command.command_group/1","type":"function"},{"doc":"* `heading` (`:string`) (required)","ref":"SaladUI.Command.html#command_group/1-attributes","title":"Attributes - SaladUI.Command.command_group/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Command.html#command_group/1-slots","title":"Slots - SaladUI.Command.command_group/1","type":"function"},{"doc":"Renders the input field for searching/filtering commands.","ref":"SaladUI.Command.html#command_input/1","title":"SaladUI.Command.command_input/1","type":"function"},{"doc":"* `:class` - Additional classes to apply.\n  * All global attributes are passed to the ` ` element.","ref":"SaladUI.Command.html#command_input/1-attributes","title":"Attributes - SaladUI.Command.command_input/1","type":"function"},{"doc":"<.command_input placeholder=\"Type a command...\" />","ref":"SaladUI.Command.html#command_input/1-example","title":"Example - SaladUI.Command.command_input/1","type":"function"},{"doc":"* `class` (`:any`) - Defaults to `\"\"`.\n* Global attributes are accepted.","ref":"SaladUI.Command.html#command_input/1-attributes","title":"Attributes - SaladUI.Command.command_input/1","type":"function"},{"doc":"Renders a single command item (button).","ref":"SaladUI.Command.html#command_item/1","title":"SaladUI.Command.command_item/1","type":"function"},{"doc":"* `:disabled` - Whether the item is disabled.\n  * `:selected` - Whether the item is selected.\n  * All global attributes are passed to the ` ` element.","ref":"SaladUI.Command.html#command_item/1-attributes","title":"Attributes - SaladUI.Command.command_item/1","type":"function"},{"doc":"* `:inner_block` (required) - The content of the command item.","ref":"SaladUI.Command.html#command_item/1-slots","title":"Slots - SaladUI.Command.command_item/1","type":"function"},{"doc":"<.command_item phx-click=\"select_command\">\n      <.icon name=\"calendar\" />\n       Calendar \n    </.command_item>","ref":"SaladUI.Command.html#command_item/1-example","title":"Example - SaladUI.Command.command_item/1","type":"function"},{"doc":"* `disabled` (`:boolean`) - Defaults to `false`.\n* `selected` (`:boolean`) - Defaults to `false`.\n* Global attributes are accepted.","ref":"SaladUI.Command.html#command_item/1-attributes","title":"Attributes - SaladUI.Command.command_item/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Command.html#command_item/1-slots","title":"Slots - SaladUI.Command.command_item/1","type":"function"},{"doc":"Renders the list container for command items and groups.","ref":"SaladUI.Command.html#command_list/1","title":"SaladUI.Command.command_list/1","type":"function"},{"doc":"* `:class` - Additional classes to apply.","ref":"SaladUI.Command.html#command_list/1-attributes","title":"Attributes - SaladUI.Command.command_list/1","type":"function"},{"doc":"* `:inner_block` (required) - The content of the command list (groups/items).","ref":"SaladUI.Command.html#command_list/1-slots","title":"Slots - SaladUI.Command.command_list/1","type":"function"},{"doc":"<.command_list>\n      <.command_group heading=\"Actions\">\n        <.command_item>...</.command_item>\n      </.command_group>\n    </.command_list>","ref":"SaladUI.Command.html#command_list/1-example","title":"Example - SaladUI.Command.command_list/1","type":"function"},{"doc":"* `class` (`:any`) - Defaults to `\"\"`.","ref":"SaladUI.Command.html#command_list/1-attributes","title":"Attributes - SaladUI.Command.command_list/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Command.html#command_list/1-slots","title":"Slots - SaladUI.Command.command_list/1","type":"function"},{"doc":"Renders a keyboard shortcut hint for a command item.","ref":"SaladUI.Command.html#command_shortcut/1","title":"SaladUI.Command.command_shortcut/1","type":"function"},{"doc":"* `:class` - Additional classes to apply.","ref":"SaladUI.Command.html#command_shortcut/1-attributes","title":"Attributes - SaladUI.Command.command_shortcut/1","type":"function"},{"doc":"* `:inner_block` (required) - The shortcut text.","ref":"SaladUI.Command.html#command_shortcut/1-slots","title":"Slots - SaladUI.Command.command_shortcut/1","type":"function"},{"doc":"<.command_shortcut>⌘P</.command_shortcut>","ref":"SaladUI.Command.html#command_shortcut/1-example","title":"Example - SaladUI.Command.command_shortcut/1","type":"function"},{"doc":"* `class` (`:any`) - Defaults to `\"\"`.","ref":"SaladUI.Command.html#command_shortcut/1-attributes","title":"Attributes - SaladUI.Command.command_shortcut/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Command.html#command_shortcut/1-slots","title":"Slots - SaladUI.Command.command_shortcut/1","type":"function"},{"doc":"Implement of Dialog components from https://ui.shadcn.com/docs/components/dialog","ref":"SaladUI.Dialog.html","title":"SaladUI.Dialog","type":"module"},{"doc":"Dialog component","ref":"SaladUI.Dialog.html#dialog/1","title":"SaladUI.Dialog.dialog/1","type":"function"},{"doc":"<.dialog id=\"pro-dialog\" open={true}>\n      <.dialog_trigger>Click me</.dialog_trigger>\n      <.dialog_content class=\"sm:max-w-[425px]\">\n        <.dialog_header>\n          <.dialog_title>Edit profile</.dialog_title>\n          <.dialog_description>\n            Make changes to your profile here click save when you're done\n          </.dialog_description>\n        </.dialog_header>\n         \n           \n            <.label for=\"name\" class-name=\"text-right\">\n              name\n            </.label>\n             \n           \n           \n            <.label for=\"username\" class=\"text-right\">\n              username\n            </.label>\n             \n           \n         \n        <.dialog_footer>\n          <.button type=\"submit\">save changes</.button>\n        </.dialog_footer>\n      </.dialog_content>\n    </.dialog>","ref":"SaladUI.Dialog.html#dialog/1-examples","title":"Examples: - SaladUI.Dialog.dialog/1","type":"function"},{"doc":"* `id` (`:string`) (required)\n* `open` (`:boolean`) - Defaults to `false`.\n* `class` (`:string`) - Defaults to `nil`.\n* `close-on-outside-click` (`:boolean`) - Defaults to `true`.\n* `on-open` (`:any`) - Handler for dialog open event. Support both server event handler and JS command struct. Defaults to `nil`.\n* `on-close` (`:any`) - Handler for dialog closed event. Support both server event handler and JS command struct. Defaults to `nil`.","ref":"SaladUI.Dialog.html#dialog/1-attributes","title":"Attributes - SaladUI.Dialog.dialog/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Dialog.html#dialog/1-slots","title":"Slots - SaladUI.Dialog.dialog/1","type":"function"},{"doc":"","ref":"SaladUI.Dialog.html#dialog_content/1","title":"SaladUI.Dialog.dialog_content/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.","ref":"SaladUI.Dialog.html#dialog_content/1-attributes","title":"Attributes - SaladUI.Dialog.dialog_content/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Dialog.html#dialog_content/1-slots","title":"Slots - SaladUI.Dialog.dialog_content/1","type":"function"},{"doc":"","ref":"SaladUI.Dialog.html#dialog_description/1","title":"SaladUI.Dialog.dialog_description/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.","ref":"SaladUI.Dialog.html#dialog_description/1-attributes","title":"Attributes - SaladUI.Dialog.dialog_description/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Dialog.html#dialog_description/1-slots","title":"Slots - SaladUI.Dialog.dialog_description/1","type":"function"},{"doc":"","ref":"SaladUI.Dialog.html#dialog_footer/1","title":"SaladUI.Dialog.dialog_footer/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.","ref":"SaladUI.Dialog.html#dialog_footer/1-attributes","title":"Attributes - SaladUI.Dialog.dialog_footer/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Dialog.html#dialog_footer/1-slots","title":"Slots - SaladUI.Dialog.dialog_footer/1","type":"function"},{"doc":"","ref":"SaladUI.Dialog.html#dialog_header/1","title":"SaladUI.Dialog.dialog_header/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.","ref":"SaladUI.Dialog.html#dialog_header/1-attributes","title":"Attributes - SaladUI.Dialog.dialog_header/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Dialog.html#dialog_header/1-slots","title":"Slots - SaladUI.Dialog.dialog_header/1","type":"function"},{"doc":"","ref":"SaladUI.Dialog.html#dialog_title/1","title":"SaladUI.Dialog.dialog_title/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.","ref":"SaladUI.Dialog.html#dialog_title/1-attributes","title":"Attributes - SaladUI.Dialog.dialog_title/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Dialog.html#dialog_title/1-slots","title":"Slots - SaladUI.Dialog.dialog_title/1","type":"function"},{"doc":"","ref":"SaladUI.Dialog.html#dialog_trigger/1","title":"SaladUI.Dialog.dialog_trigger/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* `as` (`:any`) - Defaults to `\"div\"`.\n* Global attributes are accepted.","ref":"SaladUI.Dialog.html#dialog_trigger/1-attributes","title":"Attributes - SaladUI.Dialog.dialog_trigger/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Dialog.html#dialog_trigger/1-slots","title":"Slots - SaladUI.Dialog.dialog_trigger/1","type":"function"},{"doc":"Implementation of dropdown menu component for SaladUI framework.\n\nDropdown menus display a list of options when a trigger element is clicked.\nThey provide a way to select from multiple options while conserving screen space.","ref":"SaladUI.DropdownMenu.html","title":"SaladUI.DropdownMenu","type":"module"},{"doc":"<.dropdown_menu id=\"user-menu\">\n      <.dropdown_menu_trigger>\n        <.button variant=\"outline\">Open Menu</.button>\n      </.dropdown_menu_trigger>\n      <.dropdown_menu_content>\n        <.dropdown_menu_label>My Account</.dropdown_menu_label>\n        <.dropdown_menu_separator />\n        <.dropdown_menu_group>\n          <.dropdown_menu_item on-select={JS.push(\"profile_selected\")}>\n            Profile\n            <.dropdown_menu_shortcut>⌘P</.dropdown_menu_shortcut>\n          </.dropdown_menu_item>\n          <.dropdown_menu_item on-select={JS.push(\"settings_selected\")}>\n            Settings\n            <.dropdown_menu_shortcut>⌘S</.dropdown_menu_shortcut>\n          </.dropdown_menu_item>\n          <.dropdown_menu_item disabled>\n            Disabled Option\n          </.dropdown_menu_item>\n        </.dropdown_menu_group>\n        <.dropdown_menu_separator />\n        <.dropdown_menu_item variant=\"destructive\" on-select={JS.push(\"logout\")}>\n          Log out\n        </.dropdown_menu_item>\n      </.dropdown_menu_content>\n    </.dropdown_menu>","ref":"SaladUI.DropdownMenu.html#module-examples","title":"Examples: - SaladUI.DropdownMenu","type":"module"},{"doc":"<.dropdown_menu id=\"options-menu\">\n      <.dropdown_menu_trigger>\n        <.button variant=\"outline\">Options</.button>\n      </.dropdown_menu_trigger>\n      <.dropdown_menu_content>\n        <.dropdown_menu_checkbox_item\n          checked={@is_bold}\n          on-checked-change={JS.push(\"toggle_bold\")}\n        >\n          Bold\n        </.dropdown_menu_checkbox_item>\n        <.dropdown_menu_checkbox_item\n          checked={@is_italic}\n          on-checked-change={JS.push(\"toggle_italic\")}\n        >\n          Italic\n        </.dropdown_menu_checkbox_item>\n      </.dropdown_menu_content>\n    </.dropdown_menu>","ref":"SaladUI.DropdownMenu.html#module-example-with-checkbox-items","title":"Example with checkbox items - SaladUI.DropdownMenu","type":"module"},{"doc":"The main dropdown menu component that manages state and positioning.","ref":"SaladUI.DropdownMenu.html#dropdown_menu/1","title":"SaladUI.DropdownMenu.dropdown_menu/1","type":"function"},{"doc":"* `:id` - Required unique identifier for the dropdown menu.\n* `:open` - Whether the dropdown is initially open. Defaults to `false`.\n* `:use-portal` - Whether to render the dropdown in a portal. Defaults to `false`.\n* `:portal-container` - CSS selector for the portal container. Defaults to `nil`.\n* `:on-open` - Handler for dropdown menu open event.\n* `:on-close` - Handler for dropdown menu close event.\n* `:class` - Additional CSS classes.","ref":"SaladUI.DropdownMenu.html#dropdown_menu/1-options","title":"Options - SaladUI.DropdownMenu.dropdown_menu/1","type":"function"},{"doc":"* `id` (`:string`) (required) - Unique identifier for the dropdown menu.\n* `open` (`:boolean`) - Whether the dropdown menu is initially open. Defaults to `false`.\n* `use-portal` (`:boolean`) - Whether to render the content in a portal. Defaults to `false`.\n* `portal-container` (`:string`) - CSS selector for the portal container. Defaults to `nil`.\n* `on-open` (`:any`) - Handler for dropdown menu open event. Defaults to `nil`.\n* `on-close` (`:any`) - Handler for dropdown menu close event. Defaults to `nil`.\n* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.DropdownMenu.html#dropdown_menu/1-attributes","title":"Attributes - SaladUI.DropdownMenu.dropdown_menu/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.DropdownMenu.html#dropdown_menu/1-slots","title":"Slots - SaladUI.DropdownMenu.dropdown_menu/1","type":"function"},{"doc":"A checkbox item in the dropdown menu that can be toggled on/off.","ref":"SaladUI.DropdownMenu.html#dropdown_menu_checkbox_item/1","title":"SaladUI.DropdownMenu.dropdown_menu_checkbox_item/1","type":"function"},{"doc":"* `:checked` - Whether the item is initially checked. Defaults to `false`.\n* `:disabled` - Whether the item is disabled. Defaults to `false`.\n* `:on-checked-change` - Handler for when checked state changes.\n* `:on-select` - Handler for item selection.\n* `:class` - Additional CSS classes.","ref":"SaladUI.DropdownMenu.html#dropdown_menu_checkbox_item/1-options","title":"Options - SaladUI.DropdownMenu.dropdown_menu_checkbox_item/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* `value` (`:string`) - Defaults to `nil`.\n* `checked` (`:boolean`) - Defaults to `false`.\n* `disabled` (`:boolean`) - Defaults to `false`.\n* `on-select` (`:any`) - Handler for item selected event. Defaults to `nil`.\n* `on-checked-change` (`:any`) - Handler for when checked state changes. Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.DropdownMenu.html#dropdown_menu_checkbox_item/1-attributes","title":"Attributes - SaladUI.DropdownMenu.dropdown_menu_checkbox_item/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.DropdownMenu.html#dropdown_menu_checkbox_item/1-slots","title":"Slots - SaladUI.DropdownMenu.dropdown_menu_checkbox_item/1","type":"function"},{"doc":"The dropdown menu content that appears when triggered.","ref":"SaladUI.DropdownMenu.html#dropdown_menu_content/1","title":"SaladUI.DropdownMenu.dropdown_menu_content/1","type":"function"},{"doc":"* `:side` - Placement of the dropdown menu relative to the trigger (top, right, bottom, left). Defaults to `\"bottom\"`.\n* `:align` - Alignment of the dropdown menu (start, center, end). Defaults to `\"start\"`.\n* `:side-offset` - Distance from the trigger in pixels. Defaults to `4`.\n* `:align-offset` - Offset along the alignment axis. Defaults to `0`.\n* `:class` - Additional CSS classes.","ref":"SaladUI.DropdownMenu.html#dropdown_menu_content/1-options","title":"Options - SaladUI.DropdownMenu.dropdown_menu_content/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* `side` (`:string`) - Defaults to `\"bottom\"`.\n* `align` (`:string`) - Defaults to `\"start\"`.\n* `side-offset` (`:integer`) - Distance from the trigger in pixels. Defaults to `4`.\n* `align-offset` (`:integer`) - Offset along the alignment axis. Defaults to `0`.\n* Global attributes are accepted.","ref":"SaladUI.DropdownMenu.html#dropdown_menu_content/1-attributes","title":"Attributes - SaladUI.DropdownMenu.dropdown_menu_content/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.DropdownMenu.html#dropdown_menu_content/1-slots","title":"Slots - SaladUI.DropdownMenu.dropdown_menu_content/1","type":"function"},{"doc":"A group of related dropdown menu items.","ref":"SaladUI.DropdownMenu.html#dropdown_menu_group/1","title":"SaladUI.DropdownMenu.dropdown_menu_group/1","type":"function"},{"doc":"* `:class` - Additional CSS classes.","ref":"SaladUI.DropdownMenu.html#dropdown_menu_group/1-options","title":"Options - SaladUI.DropdownMenu.dropdown_menu_group/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.DropdownMenu.html#dropdown_menu_group/1-attributes","title":"Attributes - SaladUI.DropdownMenu.dropdown_menu_group/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.DropdownMenu.html#dropdown_menu_group/1-slots","title":"Slots - SaladUI.DropdownMenu.dropdown_menu_group/1","type":"function"},{"doc":"An item in the dropdown menu.","ref":"SaladUI.DropdownMenu.html#dropdown_menu_item/1","title":"SaladUI.DropdownMenu.dropdown_menu_item/1","type":"function"},{"doc":"* `:disabled` - Whether the item is disabled. Defaults to `false`.\n* `:variant` - Visual style variant of the item (default or destructive).\n* `:on-select` - Handler for item selection.\n* `:class` - Additional CSS classes.","ref":"SaladUI.DropdownMenu.html#dropdown_menu_item/1-options","title":"Options - SaladUI.DropdownMenu.dropdown_menu_item/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* `value` (`:string`) - Defaults to `nil`.\n* `variant` (`:string`) - Defaults to `\"default\"`.\n* `disabled` (`:boolean`) - Defaults to `false`.\n* `on-select` (`:any`) - Handler for item selection. Defaults to `nil`.\n* `as` (`:any`) - Defaults to `\"div\"`.\n* Global attributes are accepted.","ref":"SaladUI.DropdownMenu.html#dropdown_menu_item/1-attributes","title":"Attributes - SaladUI.DropdownMenu.dropdown_menu_item/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.DropdownMenu.html#dropdown_menu_item/1-slots","title":"Slots - SaladUI.DropdownMenu.dropdown_menu_item/1","type":"function"},{"doc":"A label for a section in the dropdown menu.","ref":"SaladUI.DropdownMenu.html#dropdown_menu_label/1","title":"SaladUI.DropdownMenu.dropdown_menu_label/1","type":"function"},{"doc":"* `:inset` - Whether to inset the label. Defaults to `false`.\n* `:class` - Additional CSS classes.","ref":"SaladUI.DropdownMenu.html#dropdown_menu_label/1-options","title":"Options - SaladUI.DropdownMenu.dropdown_menu_label/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* `inset` (`:boolean`) - Defaults to `false`.\n* Global attributes are accepted.","ref":"SaladUI.DropdownMenu.html#dropdown_menu_label/1-attributes","title":"Attributes - SaladUI.DropdownMenu.dropdown_menu_label/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.DropdownMenu.html#dropdown_menu_label/1-slots","title":"Slots - SaladUI.DropdownMenu.dropdown_menu_label/1","type":"function"},{"doc":"An item in the dropdown menu.","ref":"SaladUI.DropdownMenu.html#dropdown_menu_link_item/1","title":"SaladUI.DropdownMenu.dropdown_menu_link_item/1","type":"function"},{"doc":"* `:disabled` - Whether the item is disabled. Defaults to `false`.\n* `:variant` - Visual style variant of the item (default or destructive).\n* `:on-select` - Handler for item selection.\n* `:class` - Additional CSS classes.","ref":"SaladUI.DropdownMenu.html#dropdown_menu_link_item/1-options","title":"Options - SaladUI.DropdownMenu.dropdown_menu_link_item/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* `value` (`:string`) - Defaults to `nil`.\n* `variant` (`:string`) - Defaults to `\"default\"`.\n* `disabled` (`:boolean`) - Defaults to `false`.\n* Global attributes are accepted. Supports all globals plus: `[\"href\", \"method\"]`.","ref":"SaladUI.DropdownMenu.html#dropdown_menu_link_item/1-attributes","title":"Attributes - SaladUI.DropdownMenu.dropdown_menu_link_item/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.DropdownMenu.html#dropdown_menu_link_item/1-slots","title":"Slots - SaladUI.DropdownMenu.dropdown_menu_link_item/1","type":"function"},{"doc":"A separator for visually dividing sections of the dropdown menu.","ref":"SaladUI.DropdownMenu.html#dropdown_menu_separator/1","title":"SaladUI.DropdownMenu.dropdown_menu_separator/1","type":"function"},{"doc":"* `:class` - Additional CSS classes.","ref":"SaladUI.DropdownMenu.html#dropdown_menu_separator/1-options","title":"Options - SaladUI.DropdownMenu.dropdown_menu_separator/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.DropdownMenu.html#dropdown_menu_separator/1-attributes","title":"Attributes - SaladUI.DropdownMenu.dropdown_menu_separator/1","type":"function"},{"doc":"* `inner_block`","ref":"SaladUI.DropdownMenu.html#dropdown_menu_separator/1-slots","title":"Slots - SaladUI.DropdownMenu.dropdown_menu_separator/1","type":"function"},{"doc":"A keyboard shortcut hint displayed in a dropdown menu item.","ref":"SaladUI.DropdownMenu.html#dropdown_menu_shortcut/1","title":"SaladUI.DropdownMenu.dropdown_menu_shortcut/1","type":"function"},{"doc":"* `:class` - Additional CSS classes.","ref":"SaladUI.DropdownMenu.html#dropdown_menu_shortcut/1-options","title":"Options - SaladUI.DropdownMenu.dropdown_menu_shortcut/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.DropdownMenu.html#dropdown_menu_shortcut/1-attributes","title":"Attributes - SaladUI.DropdownMenu.dropdown_menu_shortcut/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.DropdownMenu.html#dropdown_menu_shortcut/1-slots","title":"Slots - SaladUI.DropdownMenu.dropdown_menu_shortcut/1","type":"function"},{"doc":"The trigger element that toggles the dropdown menu.","ref":"SaladUI.DropdownMenu.html#dropdown_menu_trigger/1","title":"SaladUI.DropdownMenu.dropdown_menu_trigger/1","type":"function"},{"doc":"* `:class` - Additional CSS classes.\n* `:as` - The HTML tag to use for the trigger. Defaults to `\"div\"`.","ref":"SaladUI.DropdownMenu.html#dropdown_menu_trigger/1-options","title":"Options - SaladUI.DropdownMenu.dropdown_menu_trigger/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* `as` (`:any`) - Defaults to `\"div\"`.\n* Global attributes are accepted.","ref":"SaladUI.DropdownMenu.html#dropdown_menu_trigger/1-attributes","title":"Attributes - SaladUI.DropdownMenu.dropdown_menu_trigger/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.DropdownMenu.html#dropdown_menu_trigger/1-slots","title":"Slots - SaladUI.DropdownMenu.dropdown_menu_trigger/1","type":"function"},{"doc":"Form-related components that help build accessible forms.\n\nSaladUI doesn't define its own form component, but instead provides a set of\nform-related components to enhance the native Phoenix LiveView form.","ref":"SaladUI.Form.html","title":"SaladUI.Form","type":"module"},{"doc":"<.form\n      class=\"space-y-6\"\n      for={@form}\n      id=\"project-form\"\n      phx-target={@myself}\n      phx-change=\"validate\"\n      phx-submit=\"save\"\n    >\n      <.form_item>\n        <.form_label>What is your project's name?</.form_label>\n        <.form_control>\n          <.input field={@form[:name]} type=\"text\" phx-debounce=\"500\" />\n        </.form_control>\n        <.form_description>\n          This is your public display name.\n        </.form_description>\n        <.form_message field={@form[:name]} />\n      </.form_item>\n\n       \n        <.button\n          class=\"btn btn-secondary btn-md\"\n          icon=\"inbox_arrow_down\"\n          phx-disable-with=\"Saving...\"\n        >\n          Save project\n        </.button>\n       \n    </.form>","ref":"SaladUI.Form.html#module-examples","title":"Examples: - SaladUI.Form","type":"module"},{"doc":"Form control component that wraps input elements.\n\nThis is a simple pass-through component that renders its inner block.","ref":"SaladUI.Form.html#form_control/1","title":"SaladUI.Form.form_control/1","type":"function"},{"doc":"<.form_control>\n      <.input field={@form[:email]} type=\"email\" />\n    </.form_control>","ref":"SaladUI.Form.html#form_control/1-examples","title":"Examples: - SaladUI.Form.form_control/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Form.html#form_control/1-slots","title":"Slots - SaladUI.Form.form_control/1","type":"function"},{"doc":"Form description component that provides additional context for a form field.","ref":"SaladUI.Form.html#form_description/1","title":"SaladUI.Form.form_description/1","type":"function"},{"doc":"<.form_description>\n      We'll only use your email for account-related purposes.\n    </.form_description>","ref":"SaladUI.Form.html#form_description/1-examples","title":"Examples: - SaladUI.Form.form_description/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Form.html#form_description/1-attributes","title":"Attributes - SaladUI.Form.form_description/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Form.html#form_description/1-slots","title":"Slots - SaladUI.Form.form_description/1","type":"function"},{"doc":"Form item component that acts as a container for a form field.","ref":"SaladUI.Form.html#form_item/1","title":"SaladUI.Form.form_item/1","type":"function"},{"doc":"<.form_item>\n      <.form_label>Email</.form_label>\n      <.form_control>\n        <.input field={@form[:email]} type=\"email\" />\n      </.form_control>\n      <.form_message field={@form[:email]} />\n    </.form_item>","ref":"SaladUI.Form.html#form_item/1-examples","title":"Examples: - SaladUI.Form.form_item/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Form.html#form_item/1-attributes","title":"Attributes - SaladUI.Form.form_item/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Form.html#form_item/1-slots","title":"Slots - SaladUI.Form.form_item/1","type":"function"},{"doc":"Form label component that renders a label for a form field.\n\nShows validation errors through text color when a field has errors.","ref":"SaladUI.Form.html#form_label/1","title":"SaladUI.Form.form_label/1","type":"function"},{"doc":"<.form_label>Email</.form_label>\n    <.form_label field={@form[:email]}>Email</.form_label>","ref":"SaladUI.Form.html#form_label/1-examples","title":"Examples: - SaladUI.Form.form_label/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* `field` (`Phoenix.HTML.FormField`) - a form field struct retrieved from the form, for example: @form[:email]. Defaults to `nil`.\n* `for` (`:string`) - Defaults to `nil`.\n* `error` (`:boolean`) - whether the field has an error. Defaults to `false`.\n* Global attributes are accepted.","ref":"SaladUI.Form.html#form_label/1-attributes","title":"Attributes - SaladUI.Form.form_label/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Form.html#form_label/1-slots","title":"Slots - SaladUI.Form.form_label/1","type":"function"},{"doc":"Form message component that displays validation errors for a form field.","ref":"SaladUI.Form.html#form_message/1","title":"SaladUI.Form.form_message/1","type":"function"},{"doc":"<.form_message field={@form[:email]} />\n\n    <.form_message>\n      Please enter a valid email address.\n    </.form_message>","ref":"SaladUI.Form.html#form_message/1-examples","title":"Examples: - SaladUI.Form.form_message/1","type":"function"},{"doc":"* `field` (`Phoenix.HTML.FormField`) - a form field struct retrieved from the form, for example: @form[:email]. Defaults to `nil`.\n* `errors` (`:any`) - a list of error messages to display. Defaults to `[]`.\n* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Form.html#form_message/1-attributes","title":"Attributes - SaladUI.Form.form_message/1","type":"function"},{"doc":"* `inner_block`","ref":"SaladUI.Form.html#form_message/1-slots","title":"Slots - SaladUI.Form.form_message/1","type":"function"},{"doc":"Implementation of hover card component with positioning and hover interactions.\n\nWhen a user hovers over the trigger element, the content card appears with a small delay.\nThe card disappears when the user moves away from both the trigger and the content.","ref":"SaladUI.HoverCard.html","title":"SaladUI.HoverCard","type":"module"},{"doc":"<.hover_card id=\"user-hover-card\">\n      <.hover_card_trigger>\n        <.button variant=\"link\">@salad_ui</.button>\n      </.hover_card_trigger>\n      <.hover_card_content>\n         \n           \n             \n             \n               SaladUI \n               @salad_ui \n             \n           \n           \n            UI component library for modern web applications.\n           \n         \n      </.hover_card_content>\n    </.hover_card>","ref":"SaladUI.HoverCard.html#module-examples","title":"Examples: - SaladUI.HoverCard","type":"module"},{"doc":"The main hover card component that manages state and positioning.","ref":"SaladUI.HoverCard.html#hover_card/1","title":"SaladUI.HoverCard.hover_card/1","type":"function"},{"doc":"* `:id` - Required unique identifier for the hover card.\n* `:open-delay` - Delay in milliseconds before opening the hover card. Defaults to `300`.\n* `:close-delay` - Delay in milliseconds before closing the hover card. Defaults to `200`.\n* `:on-open` - Handler for hover card open event.\n* `:on-close` - Handler for hover card close event.\n* `:class` - Additional CSS classes.","ref":"SaladUI.HoverCard.html#hover_card/1-options","title":"Options - SaladUI.HoverCard.hover_card/1","type":"function"},{"doc":"* `id` (`:string`) (required) - Unique identifier for the hover card.\n* `open-delay` (`:integer`) - Delay in milliseconds before opening the hover card. Defaults to `300`.\n* `close-delay` (`:integer`) - Delay in milliseconds before closing the hover card. Defaults to `200`.\n* `on-open` (`:any`) - Handler for hover card open event. Defaults to `nil`.\n* `on-close` (`:any`) - Handler for hover card close event. Defaults to `nil`.\n* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.HoverCard.html#hover_card/1-attributes","title":"Attributes - SaladUI.HoverCard.hover_card/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.HoverCard.html#hover_card/1-slots","title":"Slots - SaladUI.HoverCard.hover_card/1","type":"function"},{"doc":"The hover card content that appears when triggered.","ref":"SaladUI.HoverCard.html#hover_card_content/1","title":"SaladUI.HoverCard.hover_card_content/1","type":"function"},{"doc":"* `:side` - Placement of the hover card relative to the trigger (top, right, bottom, left). Defaults to `\"top\"`.\n* `:align` - Alignment of the hover card (start, center, end). Defaults to `\"center\"`.\n* `:side-offset` - Distance from the trigger in pixels. Defaults to `4`.\n* `:align-offset` - Offset along the alignment axis. Defaults to `0`.\n* `:class` - Additional CSS classes.","ref":"SaladUI.HoverCard.html#hover_card_content/1-options","title":"Options - SaladUI.HoverCard.hover_card_content/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* `side` (`:string`) - Defaults to `\"top\"`.\n* `align` (`:string`) - Defaults to `\"center\"`.\n* `side-offset` (`:integer`) - Distance from the trigger in pixels. Defaults to `8`.\n* `align-offset` (`:integer`) - Offset along the alignment axis. Defaults to `0`.\n* Global attributes are accepted.","ref":"SaladUI.HoverCard.html#hover_card_content/1-attributes","title":"Attributes - SaladUI.HoverCard.hover_card_content/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.HoverCard.html#hover_card_content/1-slots","title":"Slots - SaladUI.HoverCard.hover_card_content/1","type":"function"},{"doc":"The trigger element that activates the hover card when hovered.","ref":"SaladUI.HoverCard.html#hover_card_trigger/1","title":"SaladUI.HoverCard.hover_card_trigger/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.HoverCard.html#hover_card_trigger/1-attributes","title":"Attributes - SaladUI.HoverCard.hover_card_trigger/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.HoverCard.html#hover_card_trigger/1-slots","title":"Slots - SaladUI.HoverCard.hover_card_trigger/1","type":"function"},{"doc":"Renders a [Heroicon](https://heroicons.com).\n\nHeroicons come in three styles – outline, solid, and mini.\nBy default, the outline style is used, but solid and mini may\nbe applied by using the `-solid` and `-mini` suffix.\n\nYou can customize the size and colors of the icons by setting\nwidth, height, and background color classes.\n\nIcons are extracted from your `assets/vendor/heroicons` directory and bundled\nwithin your compiled app.css by the plugin in your `assets/tailwind.config.js`.","ref":"SaladUI.Icon.html","title":"SaladUI.Icon","type":"module"},{"doc":"<.icon name=\"hero-x-mark-solid\" />\n    <.icon name=\"hero-arrow-path\" class=\"ml-1 w-3 h-3 animate-spin\" />","ref":"SaladUI.Icon.html#module-examples","title":"Examples - SaladUI.Icon","type":"module"},{"doc":"","ref":"SaladUI.Icon.html#icon/1","title":"SaladUI.Icon.icon/1","type":"function"},{"doc":"* `name` (`:string`) (required)\n* `class` (`:string`) - Defaults to `\"\"`.","ref":"SaladUI.Icon.html#icon/1-attributes","title":"Attributes - SaladUI.Icon.icon/1","type":"function"},{"doc":"Implementation of an input component for various form input types.","ref":"SaladUI.Input.html","title":"SaladUI.Input","type":"module"},{"doc":"<.input type=\"text\" placeholder=\"Enter your name\" />\n    <.input type=\"email\" placeholder=\"Enter your email\" />\n    <.input type=\"password\" placeholder=\"Enter your password\" />\n    <.input field={f[:email]} type=\"email\" placeholder=\"Enter your email\" />","ref":"SaladUI.Input.html#module-examples","title":"Examples: - SaladUI.Input","type":"module"},{"doc":"Renders a form input field or a component that looks like an input field.","ref":"SaladUI.Input.html#input/1","title":"SaladUI.Input.input/1","type":"function"},{"doc":"* `:id` - The id to use for the input\n* `:name` - The name to use for the input\n* `:value` - The value to pre-populate the input with\n* `:type` - The type of input (text, email, password, etc.)\n* `:default-value` - The default value of the input\n* `:field` - A form field struct to build the input from\n* `:class` - Additional CSS classes to apply\n* `:placeholder` - Placeholder text (passed through as rest)\n* `:disabled` - Whether the input is disabled (passed through as rest)\n* `:required` - Whether the input is required (passed through as rest)\n* `:readonly` - Whether the input is readonly (passed through as rest)\n* `:autocomplete` - Hints for form autofill feature (passed through as rest)","ref":"SaladUI.Input.html#input/1-options","title":"Options - SaladUI.Input.input/1","type":"function"},{"doc":"* `id` (`:any`) - Defaults to `nil`.\n* `name` (`:any`) - Defaults to `nil`.\n* `value` (`:any`)\n* `type` (`:string`) - Defaults to `\"text\"`.\n* `default-value` (`:any`)\n* `field` (`Phoenix.HTML.FormField`) - a form field struct retrieved from the form, for example: @form[:email].\n* `class` (`:any`) - Defaults to `nil`.\n* Global attributes are accepted. Supports all globals plus: `[\"accept\", \"autocomplete\", \"capture\", \"cols\", \"disabled\", \"form\", \"list\", \"max\", \"maxlength\", \"min\", \"minlength\", \"multiple\", \"pattern\", \"placeholder\", \"readonly\", \"required\", \"rows\", \"size\", \"step\"]`.","ref":"SaladUI.Input.html#input/1-attributes","title":"Attributes - SaladUI.Input.input/1","type":"function"},{"doc":"Helper functions for integrating SaladUI with Phoenix LiveView using JavaScript commands.","ref":"SaladUI.JS.html","title":"SaladUI.JS","type":"module"},{"doc":"Dispatch a command to a SaladUI component using JavaScript.\nThis is useful for programmatically controlling components from client-side code.","ref":"SaladUI.JS.html#dispatch_command/3","title":"SaladUI.JS.dispatch_command/3","type":"function"},{"doc":"- `js`: The JavaScript object.\n- `command_name`: The name of the command to dispatch.\n- `opts`: Options for the command, including `:detail` for additional parameters.","ref":"SaladUI.JS.html#dispatch_command/3-parameters","title":"Parameters - SaladUI.JS.dispatch_command/3","type":"function"},{"doc":"This function use JS.dispatch to send a command to the component similar to `send_command/4`.\n\nEach component listens for the `salad_ui:command` event and executes the corresponding command similar to the way it handle `send_command/4` from server side .","ref":"SaladUI.JS.html#dispatch_command/3-how-it-works","title":"How it works - SaladUI.JS.dispatch_command/3","type":"function"},{"doc":"```elixir\n  SaladUI.JS.dispatch_command(\"open\", to: \"#dialog\")}> Click me  \n```","ref":"SaladUI.JS.html#dispatch_command/3-example","title":"Example - SaladUI.JS.dispatch_command/3","type":"function"},{"doc":"Helper functions for integrating SaladUI with Phoenix LiveView.","ref":"SaladUI.LiveView.html","title":"SaladUI.LiveView","type":"module"},{"doc":"Send a command to a SaladUI component.\nThis is useful for programmatically controlling components from server-side code.","ref":"SaladUI.LiveView.html#send_command/4","title":"SaladUI.LiveView.send_command/4","type":"function"},{"doc":"- `socket`: The LiveView socket.\n- `component_id`: The ID of the component to send the command to.\n- `command`: The name of the command to send. Command could be any transitions that component state machine support or custom commands that supported by component.\n- `params`: Optional parameters for the command.","ref":"SaladUI.LiveView.html#send_command/4-parameters","title":"Parameters - SaladUI.LiveView.send_command/4","type":"function"},{"doc":"```elixir\nsend_command(socket, \"dialog\", \"open\")\n```","ref":"SaladUI.LiveView.html#send_command/4-example","title":"Example - SaladUI.LiveView.send_command/4","type":"function"},{"doc":"Implement menu components","ref":"SaladUI.Menu.html","title":"SaladUI.Menu","type":"module"},{"doc":"Render menu","ref":"SaladUI.Menu.html#menu/1","title":"SaladUI.Menu.menu/1","type":"function"},{"doc":"<.menu>\n      <.menu_label>Account</.menu_label>\n      <.menu_separator />\n\n      <.menu_group>\n        <.menu_item>\n            Profile\n          <.menu_shortcut>⌘P</.menu_shortcut>\n        </.menu_item>\n\n        <.menu_item>\n            Billing\n          <.menu_shortcut>⌘B</.menu_shortcut>\n        </.menu_item>\n\n        <.menu_item>\n            Settings\n          <.menu_shortcut>⌘S</.menu_shortcut>\n        </.menu_item>\n      </.menu_group>\n    </.menu>","ref":"SaladUI.Menu.html#menu/1-examples","title":"Examples: - SaladUI.Menu.menu/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `\"top-0 left-full\"`.\n* Global attributes are accepted.","ref":"SaladUI.Menu.html#menu/1-attributes","title":"Attributes - SaladUI.Menu.menu/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Menu.html#menu/1-slots","title":"Slots - SaladUI.Menu.menu/1","type":"function"},{"doc":"","ref":"SaladUI.Menu.html#menu_group/1","title":"SaladUI.Menu.menu_group/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Menu.html#menu_group/1-attributes","title":"Attributes - SaladUI.Menu.menu_group/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Menu.html#menu_group/1-slots","title":"Slots - SaladUI.Menu.menu_group/1","type":"function"},{"doc":"","ref":"SaladUI.Menu.html#menu_item/1","title":"SaladUI.Menu.menu_item/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* `disabled` (`:boolean`) - Defaults to `false`.\n* Global attributes are accepted.","ref":"SaladUI.Menu.html#menu_item/1-attributes","title":"Attributes - SaladUI.Menu.menu_item/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Menu.html#menu_item/1-slots","title":"Slots - SaladUI.Menu.menu_item/1","type":"function"},{"doc":"","ref":"SaladUI.Menu.html#menu_label/1","title":"SaladUI.Menu.menu_label/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* `inset` (`:boolean`) - Defaults to `false`.\n* Global attributes are accepted.","ref":"SaladUI.Menu.html#menu_label/1-attributes","title":"Attributes - SaladUI.Menu.menu_label/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Menu.html#menu_label/1-slots","title":"Slots - SaladUI.Menu.menu_label/1","type":"function"},{"doc":"","ref":"SaladUI.Menu.html#menu_separator/1","title":"SaladUI.Menu.menu_separator/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.","ref":"SaladUI.Menu.html#menu_separator/1-attributes","title":"Attributes - SaladUI.Menu.menu_separator/1","type":"function"},{"doc":"* `inner_block`","ref":"SaladUI.Menu.html#menu_separator/1-slots","title":"Slots - SaladUI.Menu.menu_separator/1","type":"function"},{"doc":"","ref":"SaladUI.Menu.html#menu_shortcut/1","title":"SaladUI.Menu.menu_shortcut/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Menu.html#menu_shortcut/1-attributes","title":"Attributes - SaladUI.Menu.menu_shortcut/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Menu.html#menu_shortcut/1-slots","title":"Slots - SaladUI.Menu.menu_shortcut/1","type":"function"},{"doc":"Implementation of pagination component for navigation between pages of content.","ref":"SaladUI.Pagination.html","title":"SaladUI.Pagination","type":"module"},{"doc":"<.pagination>\n      <.pagination_content>\n        <.pagination_item>\n          <.pagination_previous href=\"#\" />\n        </.pagination_item>\n        <.pagination_item>\n          <.pagination_link href=\"#\" is_active={@page == 1}>1</.pagination_link>\n        </.pagination_item>\n        <.pagination_item>\n          <.pagination_link href=\"#\" is_active={@page == 2}>2</.pagination_link>\n        </.pagination_item>\n        <.pagination_item>\n          <.pagination_link href=\"#\" is_active={@page == 3}>3</.pagination_link>\n        </.pagination_item>\n        <.pagination_item>\n          <.pagination_ellipsis />\n        </.pagination_item>\n        <.pagination_item>\n          <.pagination_next href=\"#\" />\n        </.pagination_item>\n      </.pagination_content>\n    </.pagination>","ref":"SaladUI.Pagination.html#module-examples","title":"Examples: - SaladUI.Pagination","type":"module"},{"doc":"Renders a pagination component.","ref":"SaladUI.Pagination.html#pagination/1","title":"SaladUI.Pagination.pagination/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Pagination.html#pagination/1-attributes","title":"Attributes - SaladUI.Pagination.pagination/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Pagination.html#pagination/1-slots","title":"Slots - SaladUI.Pagination.pagination/1","type":"function"},{"doc":"Renders pagination content wrapper.","ref":"SaladUI.Pagination.html#pagination_content/1","title":"SaladUI.Pagination.pagination_content/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Pagination.html#pagination_content/1-attributes","title":"Attributes - SaladUI.Pagination.pagination_content/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Pagination.html#pagination_content/1-slots","title":"Slots - SaladUI.Pagination.pagination_content/1","type":"function"},{"doc":"Renders an ellipsis for page ranges.","ref":"SaladUI.Pagination.html#pagination_ellipsis/1","title":"SaladUI.Pagination.pagination_ellipsis/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Pagination.html#pagination_ellipsis/1-attributes","title":"Attributes - SaladUI.Pagination.pagination_ellipsis/1","type":"function"},{"doc":"Renders a pagination item container.","ref":"SaladUI.Pagination.html#pagination_item/1","title":"SaladUI.Pagination.pagination_item/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Pagination.html#pagination_item/1-attributes","title":"Attributes - SaladUI.Pagination.pagination_item/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Pagination.html#pagination_item/1-slots","title":"Slots - SaladUI.Pagination.pagination_item/1","type":"function"},{"doc":"Renders a pagination link.","ref":"SaladUI.Pagination.html#pagination_link/1","title":"SaladUI.Pagination.pagination_link/1","type":"function"},{"doc":"* `:is_active` - Whether this link represents the current page\n* `:size` - Link size variant (default, sm, lg, icon)","ref":"SaladUI.Pagination.html#pagination_link/1-options","title":"Options - SaladUI.Pagination.pagination_link/1","type":"function"},{"doc":"* `is-active` (`:boolean`) - Defaults to `false`.\n* `size` (`:string`) - Defaults to `\"icon\"`.\n* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Pagination.html#pagination_link/1-attributes","title":"Attributes - SaladUI.Pagination.pagination_link/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Pagination.html#pagination_link/1-slots","title":"Slots - SaladUI.Pagination.pagination_link/1","type":"function"},{"doc":"Renders a next page button.","ref":"SaladUI.Pagination.html#pagination_next/1","title":"SaladUI.Pagination.pagination_next/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Pagination.html#pagination_next/1-attributes","title":"Attributes - SaladUI.Pagination.pagination_next/1","type":"function"},{"doc":"Renders a previous page button.","ref":"SaladUI.Pagination.html#pagination_previous/1","title":"SaladUI.Pagination.pagination_previous/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Pagination.html#pagination_previous/1-attributes","title":"Attributes - SaladUI.Pagination.pagination_previous/1","type":"function"},{"doc":"Enhanced implementation of popover component from https://ui.shadcn.com/docs/components/popover","ref":"SaladUI.Popover.html","title":"SaladUI.Popover","type":"module"},{"doc":"<.popover id=\"profile-popover\">\n      <.popover_trigger>\n        <.button variant=\"outline\">Open Popover</.button>\n      </.popover_trigger>\n      <.popover_content side=\"bottom\" align=\"center\">\n         \n           Profile \n           View and edit your profile details \n         \n      </.popover_content>\n    </.popover>","ref":"SaladUI.Popover.html#module-example","title":"Example: - SaladUI.Popover","type":"module"},{"doc":"The main popover component that manages state and positioning.","ref":"SaladUI.Popover.html#popover/1","title":"SaladUI.Popover.popover/1","type":"function"},{"doc":"* `:id` - Required unique identifier for the popover.\n* `:open` - Whether the popover is initially open. Defaults to `false`.\n* `:animation` - Whether to animate the popover. Defaults to `true`.\n* `:on-open` - Handler for popover open event.\n* `:on-close` - Handler for popover close event.\n* `:class` - Additional CSS classes.","ref":"SaladUI.Popover.html#popover/1-options","title":"Options - SaladUI.Popover.popover/1","type":"function"},{"doc":"* `id` (`:string`) (required) - Unique identifier for the popover.\n* `open` (`:boolean`) - Whether the popover is initially open. Defaults to `false`.\n* `portal-container` (`:string`) - The portal container to render the popover in. Defaults to `nil`.\n* `class` (`:string`) - Defaults to `nil`.\n* `on-open` (`:any`) - Handler for popover open event. Defaults to `nil`.\n* `on-close` (`:any`) - Handler for popover close event. Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Popover.html#popover/1-attributes","title":"Attributes - SaladUI.Popover.popover/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Popover.html#popover/1-slots","title":"Slots - SaladUI.Popover.popover/1","type":"function"},{"doc":"The popover content that appears when triggered.","ref":"SaladUI.Popover.html#popover_content/1","title":"SaladUI.Popover.popover_content/1","type":"function"},{"doc":"* `:side` - Placement of the popover relative to the trigger (top, right, bottom, left). Defaults to `\"bottom\"`.\n* `:align` - Alignment of the popover (start, center, end). Defaults to `\"center\"`.\n* `:side-offset` - Distance from the trigger in pixels. Defaults to `8`.\n* `:align-offset` - Offset along the alignment axis. Defaults to `0`.\n* `:class` - Additional CSS classes.","ref":"SaladUI.Popover.html#popover_content/1-options","title":"Options - SaladUI.Popover.popover_content/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* `side` (`:string`) - Defaults to `\"bottom\"`.\n* `align` (`:string`) - Defaults to `\"center\"`.\n* `side-offset` (`:integer`) - Distance from the trigger in pixels. Defaults to `8`.\n* `align-offset` (`:integer`) - Offset along the alignment axis. Defaults to `0`.\n* Global attributes are accepted.","ref":"SaladUI.Popover.html#popover_content/1-attributes","title":"Attributes - SaladUI.Popover.popover_content/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Popover.html#popover_content/1-slots","title":"Slots - SaladUI.Popover.popover_content/1","type":"function"},{"doc":"The trigger element that toggles the popover.","ref":"SaladUI.Popover.html#popover_trigger/1","title":"SaladUI.Popover.popover_trigger/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Popover.html#popover_trigger/1-attributes","title":"Attributes - SaladUI.Popover.popover_trigger/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Popover.html#popover_trigger/1-slots","title":"Slots - SaladUI.Popover.popover_trigger/1","type":"function"},{"doc":"Implementation of Progress component for displaying completion percentages or loading states.\n\nProgress bars visually represent the completion status of an operation, providing\nimmediate feedback about how far along a task or process is.","ref":"SaladUI.Progress.html","title":"SaladUI.Progress","type":"module"},{"doc":"<.progress value={50} />\n    <.progress value={75} class=\"w-[60%]\" />","ref":"SaladUI.Progress.html#module-examples","title":"Examples: - SaladUI.Progress","type":"module"},{"doc":"Renders a progress bar.","ref":"SaladUI.Progress.html#progress/1","title":"SaladUI.Progress.progress/1","type":"function"},{"doc":"* `:value` - The current progress value (0-100)\n* `:class` - Additional CSS classes","ref":"SaladUI.Progress.html#progress/1-options","title":"Options - SaladUI.Progress.progress/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* `value` (`:integer`) - Current progress value (0-100). Defaults to `0`.\n* `max` (`:integer`) - Maximum value. Defaults to `100`.\n* `indeterminate` (`:boolean`) - Whether the progress is indeterminate. Defaults to `false`.\n* Global attributes are accepted.","ref":"SaladUI.Progress.html#progress/1-attributes","title":"Attributes - SaladUI.Progress.progress/1","type":"function"},{"doc":"Implementation of radio group component from https://ui.shadcn.com/docs/components/radio-group","ref":"SaladUI.RadioGroup.html","title":"SaladUI.RadioGroup","type":"module"},{"doc":"<.radio_group name=\"subscription\" default=\"monthly\" on_value_changed={JS.push(\"plan_changed\")}>\n       \n         \n          <.radio_group_item value=\"monthly\" id=\"monthly\"/>\n          <.label for=\"monthly\">Monthly \n         \n         \n          <.radio_group_item value=\"yearly\" id=\"yearly\"/>\n          <.label for=\"yearly\">Yearly \n         \n       \n    </.radio_group>","ref":"SaladUI.RadioGroup.html#module-examples","title":"Examples: - SaladUI.RadioGroup","type":"module"},{"doc":"Radio group component that allows selection of one option from a set.","ref":"SaladUI.RadioGroup.html#radio_group/1","title":"SaladUI.RadioGroup.radio_group/1","type":"function"},{"doc":"* `id` (`:string`) - Defaults to `nil`.\n* `name` (`:string`) - Defaults to `nil`.\n* `value` (`:any`) - The current value of the radio group. Defaults to `nil`.\n* `default-value` (`:any`) - The default value of the radio group. Defaults to `nil`.\n* `on-value-changed` (`:any`) - Handler for value changed event. Defaults to `nil`.\n* `field` (`Phoenix.HTML.FormField`) - a form field struct retrieved from the form, for example: @form[:email].\n* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.RadioGroup.html#radio_group/1-attributes","title":"Attributes - SaladUI.RadioGroup.radio_group/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.RadioGroup.html#radio_group/1-slots","title":"Slots - SaladUI.RadioGroup.radio_group/1","type":"function"},{"doc":"Individual radio button in a radio group.","ref":"SaladUI.RadioGroup.html#radio_group_item/1","title":"SaladUI.RadioGroup.radio_group_item/1","type":"function"},{"doc":"* `id` (`:string`) (required)\n* `value` (`:string`) (required)\n* `disabled` (`:boolean`) - Defaults to `false`.\n* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.RadioGroup.html#radio_group_item/1-attributes","title":"Attributes - SaladUI.RadioGroup.radio_group_item/1","type":"function"},{"doc":"Implementation of a scroll area component with custom styling.\n\nThe scroll area provides a consistent scrolling experience across different browsers\nand platforms, with customizable styling for the scrollbar.","ref":"SaladUI.ScrollArea.html","title":"SaladUI.ScrollArea","type":"module"},{"doc":"<.scroll_area class=\"h-[200px]\">\n       \n         Tags \n        <%= for tag <- 1..50 do %>\n           \n            v1.2.0-beta.<%= tag %>\n           \n          <.separator class=\"my-2\" />\n        <% end %>\n       \n    </.scroll_area>","ref":"SaladUI.ScrollArea.html#module-examples","title":"Examples: - SaladUI.ScrollArea","type":"module"},{"doc":"Renders a custom scrollable area.","ref":"SaladUI.ScrollArea.html#scroll_area/1","title":"SaladUI.ScrollArea.scroll_area/1","type":"function"},{"doc":"* `:class` - Additional CSS classes to apply to the scroll area container","ref":"SaladUI.ScrollArea.html#scroll_area/1-options","title":"Options - SaladUI.ScrollArea.scroll_area/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.ScrollArea.html#scroll_area/1-attributes","title":"Attributes - SaladUI.ScrollArea.scroll_area/1","type":"function"},{"doc":"* `inner_block`","ref":"SaladUI.ScrollArea.html#scroll_area/1-slots","title":"Slots - SaladUI.ScrollArea.scroll_area/1","type":"function"},{"doc":"Implement of select components from https://ui.shadcn.com/docs/components/select","ref":"SaladUI.Select.html","title":"SaladUI.Select","type":"module"},{"doc":"<.select default=\"banana\" id=\"fruit-select\">\n          <.select_trigger class=\"w-[180px]\">\n            <.select_value placeholder=\".select a fruit\"/>\n          </.select_trigger>\n          <.select_content>\n            <.select_group>\n              <.select_label>Fruits</.select_label>\n              <.select_item value=\"apple\">Apple</.select_item>\n              <.select_item value=\"banana\">Banana</.select_item>\n              <.select_item value=\"blueberry\">Blueberry</.select_item>\n              <.select_separator />\n              <.select_item disabled value=\"grapes\">Grapes</.select_item>\n              <.select_item value=\"pineapple\">Pineapple</.select_item>\n            </.select_group>\n      </.select_content>\n        </.select>\n\n      <.button type=\"submit\">Submit</.button>","ref":"SaladUI.Select.html#module-examples","title":"Examples: - SaladUI.Select","type":"module"},{"doc":"Ready to use select component with all required parts.","ref":"SaladUI.Select.html#select/1","title":"SaladUI.Select.select/1","type":"function"},{"doc":"* `id` (`:string`) - Defaults to `nil`.\n* `name` (`:any`) - Defaults to `nil`.\n* `value` (`:any`) - The value of the select. Defaults to `nil`.\n* `default-value` (`:any`) - The default value of the select. Defaults to `nil`.\n* `multiple` (`:boolean`) - Allow multiple selection. Defaults to `false`.\n* `use-portal` (`:boolean`) - Whether to render the content in a portal. Defaults to `false`.\n* `portal-container` (`:string`) - CSS selector for the portal container. Defaults to `nil`.\n* `on-value-changed` (`:any`) - Handler for value changed event. Defaults to `nil`.\n* `on-open` (`:any`) - Handler for select open event. Defaults to `nil`.\n* `on-close` (`:any`) - Handler for select closed event. Defaults to `nil`.\n* `field` (`Phoenix.HTML.FormField`) - a form field struct retrieved from the form, for example: @form[:email].\n* `label` (`:string`) - The display label of the select value. If not provided, the value will be used. Defaults to `nil`.\n* `placeholder` (`:string`) - The placeholder text when no value is selected. Defaults to `nil`.\n* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Select.html#select/1-attributes","title":"Attributes - SaladUI.Select.select/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Select.html#select/1-slots","title":"Slots - SaladUI.Select.select/1","type":"function"},{"doc":"","ref":"SaladUI.Select.html#select_content/1","title":"SaladUI.Select.select_content/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* `side` (`:string`) - Defaults to `\"bottom\"`.\n* Global attributes are accepted.","ref":"SaladUI.Select.html#select_content/1-attributes","title":"Attributes - SaladUI.Select.select_content/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Select.html#select_content/1-slots","title":"Slots - SaladUI.Select.select_content/1","type":"function"},{"doc":"","ref":"SaladUI.Select.html#select_group/1","title":"SaladUI.Select.select_group/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Select.html#select_group/1-attributes","title":"Attributes - SaladUI.Select.select_group/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Select.html#select_group/1-slots","title":"Slots - SaladUI.Select.select_group/1","type":"function"},{"doc":"","ref":"SaladUI.Select.html#select_item/1","title":"SaladUI.Select.select_item/1","type":"function"},{"doc":"* `value` (`:string`) (required)\n* `disabled` (`:boolean`) - Defaults to `false`.\n* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Select.html#select_item/1-attributes","title":"Attributes - SaladUI.Select.select_item/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Select.html#select_item/1-slots","title":"Slots - SaladUI.Select.select_item/1","type":"function"},{"doc":"","ref":"SaladUI.Select.html#select_label/1","title":"SaladUI.Select.select_label/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Select.html#select_label/1-attributes","title":"Attributes - SaladUI.Select.select_label/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Select.html#select_label/1-slots","title":"Slots - SaladUI.Select.select_label/1","type":"function"},{"doc":"","ref":"SaladUI.Select.html#select_separator/1","title":"SaladUI.Select.select_separator/1","type":"function"},{"doc":"","ref":"SaladUI.Select.html#select_trigger/1","title":"SaladUI.Select.select_trigger/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Select.html#select_trigger/1-attributes","title":"Attributes - SaladUI.Select.select_trigger/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Select.html#select_trigger/1-slots","title":"Slots - SaladUI.Select.select_trigger/1","type":"function"},{"doc":"","ref":"SaladUI.Select.html#select_value/1","title":"SaladUI.Select.select_value/1","type":"function"},{"doc":"* `placeholder` (`:string`) - Defaults to `nil`.\n* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Select.html#select_value/1-attributes","title":"Attributes - SaladUI.Select.select_value/1","type":"function"},{"doc":"Implementation of a separator component for dividing content.","ref":"SaladUI.Separator.html","title":"SaladUI.Separator","type":"module"},{"doc":"<.separator orientation=\"horizontal\" />\n    <.separator orientation=\"vertical\" class=\"h-6\" />","ref":"SaladUI.Separator.html#module-examples","title":"Examples: - SaladUI.Separator","type":"module"},{"doc":"Renders a separator.","ref":"SaladUI.Separator.html#separator/1","title":"SaladUI.Separator.separator/1","type":"function"},{"doc":"* `:orientation` - The orientation of the separator (`horizontal` or `vertical`). Defaults to `horizontal`.\n* `:class` - Additional CSS classes","ref":"SaladUI.Separator.html#separator/1-options","title":"Options - SaladUI.Separator.separator/1","type":"function"},{"doc":"* `orientation` (`:string`) - Defaults to `\"horizontal\"`.\n* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted. Supports all globals plus: `[\"disabled\", \"form\", \"name\", \"value\"]`.","ref":"SaladUI.Separator.html#separator/1-attributes","title":"Attributes - SaladUI.Separator.separator/1","type":"function"},{"doc":"Implementation of Sheet component for SaladUI framework.\n\nSheets are like dialogs that appear from the edge of the screen. They can be configured\nto slide in from different sides of the viewport.","ref":"SaladUI.Sheet.html","title":"SaladUI.Sheet","type":"module"},{"doc":"<.sheet id=\"user-sheet\">\n      <.sheet_trigger>\n        <.button variant=\"outline\">Open Sheet</.button>\n      </.sheet_trigger>\n      <.sheet_content side=\"right\">\n        <.sheet_header>\n          <.sheet_title>Edit profile</.sheet_title>\n          <.sheet_description>\n            Make changes to your profile here. Click save when you're done.\n          </.sheet_description>\n        </.sheet_header>\n         \n           \n            <.label for=\"name\" class=\"text-right\">Name</.label>\n            <.input id=\"name\" value=\"John Doe\" class=\"col-span-3\" />\n           \n         \n        <.sheet_footer>\n          <.button type=\"submit\">Save changes</.button>\n        </.sheet_footer>\n      </.sheet_content>\n    </.sheet>","ref":"SaladUI.Sheet.html#module-examples","title":"Examples: - SaladUI.Sheet","type":"module"},{"doc":"The main sheet component that manages state and positioning.","ref":"SaladUI.Sheet.html#sheet/1","title":"SaladUI.Sheet.sheet/1","type":"function"},{"doc":"* `:id` - Required unique identifier for the sheet.\n* `:open` - Whether the sheet is initially open. Defaults to `false`.\n* `:on-open` - Handler for sheet open event.\n* `:on-close` - Handler for sheet close event.\n* `:class` - Additional CSS classes.","ref":"SaladUI.Sheet.html#sheet/1-options","title":"Options - SaladUI.Sheet.sheet/1","type":"function"},{"doc":"* `id` (`:string`) (required) - Unique identifier for the sheet.\n* `open` (`:boolean`) - Whether the sheet is initially open. Defaults to `false`.\n* `class` (`:string`) - Defaults to `nil`.\n* `close-on-outside-click` (`:boolean`) - Defaults to `true`.\n* `on-open` (`:any`) - Handler for sheet open event. Defaults to `nil`.\n* `on-close` (`:any`) - Handler for sheet close event. Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Sheet.html#sheet/1-attributes","title":"Attributes - SaladUI.Sheet.sheet/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Sheet.html#sheet/1-slots","title":"Slots - SaladUI.Sheet.sheet/1","type":"function"},{"doc":"The close button for the sheet.","ref":"SaladUI.Sheet.html#sheet_close/1","title":"SaladUI.Sheet.sheet_close/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Sheet.html#sheet_close/1-attributes","title":"Attributes - SaladUI.Sheet.sheet_close/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Sheet.html#sheet_close/1-slots","title":"Slots - SaladUI.Sheet.sheet_close/1","type":"function"},{"doc":"The sheet content that appears when triggered.","ref":"SaladUI.Sheet.html#sheet_content/1","title":"SaladUI.Sheet.sheet_content/1","type":"function"},{"doc":"* `:side` - The side from which the sheet appears (top, right, bottom, left). Defaults to `\"right\"`.\n* `:class` - Additional CSS classes to customize dimensions and appearance.","ref":"SaladUI.Sheet.html#sheet_content/1-options","title":"Options - SaladUI.Sheet.sheet_content/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* `side` (`:string`) - The side from which the sheet appears. Defaults to `\"right\"`.\n* Global attributes are accepted.","ref":"SaladUI.Sheet.html#sheet_content/1-attributes","title":"Attributes - SaladUI.Sheet.sheet_content/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Sheet.html#sheet_content/1-slots","title":"Slots - SaladUI.Sheet.sheet_content/1","type":"function"},{"doc":"Renders a sheet description within the header section.","ref":"SaladUI.Sheet.html#sheet_description/1","title":"SaladUI.Sheet.sheet_description/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Sheet.html#sheet_description/1-attributes","title":"Attributes - SaladUI.Sheet.sheet_description/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Sheet.html#sheet_description/1-slots","title":"Slots - SaladUI.Sheet.sheet_description/1","type":"function"},{"doc":"Renders a footer section for the sheet, typically containing actions.","ref":"SaladUI.Sheet.html#sheet_footer/1","title":"SaladUI.Sheet.sheet_footer/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Sheet.html#sheet_footer/1-attributes","title":"Attributes - SaladUI.Sheet.sheet_footer/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Sheet.html#sheet_footer/1-slots","title":"Slots - SaladUI.Sheet.sheet_footer/1","type":"function"},{"doc":"Renders a sheet header section for title and description.","ref":"SaladUI.Sheet.html#sheet_header/1","title":"SaladUI.Sheet.sheet_header/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Sheet.html#sheet_header/1-attributes","title":"Attributes - SaladUI.Sheet.sheet_header/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Sheet.html#sheet_header/1-slots","title":"Slots - SaladUI.Sheet.sheet_header/1","type":"function"},{"doc":"Renders a sheet title within the header section.","ref":"SaladUI.Sheet.html#sheet_title/1","title":"SaladUI.Sheet.sheet_title/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Sheet.html#sheet_title/1-attributes","title":"Attributes - SaladUI.Sheet.sheet_title/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Sheet.html#sheet_title/1-slots","title":"Slots - SaladUI.Sheet.sheet_title/1","type":"function"},{"doc":"The trigger element that opens the sheet.","ref":"SaladUI.Sheet.html#sheet_trigger/1","title":"SaladUI.Sheet.sheet_trigger/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Sheet.html#sheet_trigger/1-attributes","title":"Attributes - SaladUI.Sheet.sheet_trigger/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Sheet.html#sheet_trigger/1-slots","title":"Slots - SaladUI.Sheet.sheet_trigger/1","type":"function"},{"doc":"Skeleton loading component for showing placeholder content while data is loading.\n\nSkeleton loaders provide visual feedback to users during data loading, improving perceived performance.","ref":"SaladUI.Skeleton.html","title":"SaladUI.Skeleton","type":"module"},{"doc":"<.skeleton class=\"h-4 w-full\" />\n\n    # Card loading skeleton\n     \n      <.skeleton class=\"h-32 w-full rounded-lg\" />\n      <.skeleton class=\"h-4 w-2/3\" />\n      <.skeleton class=\"h-4 w-full\" />\n      <.skeleton class=\"h-4 w-full\" />\n     \n\n    # Avatar and text loading skeleton\n     \n      <.skeleton class=\"h-12 w-12 rounded-full\" />\n       \n        <.skeleton class=\"h-4 w-32\" />\n        <.skeleton class=\"h-4 w-24\" />","ref":"SaladUI.Skeleton.html#module-examples","title":"Examples: - SaladUI.Skeleton","type":"module"},{"doc":"Renders a skeleton loading placeholder.","ref":"SaladUI.Skeleton.html#skeleton/1","title":"SaladUI.Skeleton.skeleton/1","type":"function"},{"doc":"* `:class` - Additional CSS classes to apply to the skeleton element. Use this to control\n  dimensions (width, height), border radius and other visual aspects.\n* `:rest` - Additional HTML attributes to apply to the skeleton element.","ref":"SaladUI.Skeleton.html#skeleton/1-attributes","title":"Attributes - SaladUI.Skeleton.skeleton/1","type":"function"},{"doc":"<.skeleton class=\"h-6 w-24\" />\n    <.skeleton class=\"h-12 w-12 rounded-full\" />\n    <.skeleton class=\"h-4 w-full max-w-sm\" />","ref":"SaladUI.Skeleton.html#skeleton/1-examples","title":"Examples - SaladUI.Skeleton.skeleton/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Skeleton.html#skeleton/1-attributes","title":"Attributes - SaladUI.Skeleton.skeleton/1","type":"function"},{"doc":"Implementation of slider component for selecting values within a range.\n\nSliders provide users with a visual representation of a value within a range,\nand allow them to adjust it by dragging a thumb or pressing arrow keys.","ref":"SaladUI.Slider.html","title":"SaladUI.Slider","type":"module"},{"doc":"<.slider id=\"volume-slider\" min={0} max={100} value={50} on-value-changed={JS.push(\"volume_changed\")} />\n\n    <.slider id=\"price-range\" min={10} max={1000} step={10} value={500} class=\"w-[300px]\" />","ref":"SaladUI.Slider.html#module-examples","title":"Examples: - SaladUI.Slider","type":"module"},{"doc":"Renders a slider component.","ref":"SaladUI.Slider.html#slider/1","title":"SaladUI.Slider.slider/1","type":"function"},{"doc":"* `:id` - Required unique identifier for the slider.\n* `:min` - Minimum value (defaults to 0).\n* `:max` - Maximum value (defaults to 100).\n* `:step` - Step size for value changes (defaults to 1).\n* `:value` - Current value of the slider (defaults to min).\n* `:default-value` - Default value if value is not provided.\n* `:disabled` - Whether the slider is disabled (defaults to false).\n* `:on-value-changed` - Handler for value changed event.\n* `:class` - Additional CSS classes.","ref":"SaladUI.Slider.html#slider/1-options","title":"Options - SaladUI.Slider.slider/1","type":"function"},{"doc":"* `id` (`:string`) (required) - Unique identifier for the slider.\n* `name` (`:any`) - Name of the slider for form submission. Defaults to `nil`.\n* `min` (`:integer`) - Minimum value. Defaults to `0`.\n* `max` (`:integer`) - Maximum value. Defaults to `100`.\n* `step` (`:integer`) - Step size for value changes. Defaults to `1`.\n* `value` (`:integer`) - Current value of the slider. Defaults to `nil`.\n* `default-value` (`:integer`) - Default value if value is not provided. Defaults to `nil`.\n* `disabled` (`:boolean`) - Whether the slider is disabled. Defaults to `false`.\n* `on-value-changed` (`:any`) - Handler for value changed event. Defaults to `nil`.\n* `field` (`Phoenix.HTML.FormField`) - A form field struct retrieved from the form, for example: @form[:volume].\n* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Slider.html#slider/1-attributes","title":"Attributes - SaladUI.Slider.slider/1","type":"function"},{"doc":"Implementation of a switch/toggle component.\n\nA switch is a control that allows users to toggle between checked and not checked states.","ref":"SaladUI.Switch.html","title":"SaladUI.Switch","type":"module"},{"doc":"Renders a switch component.","ref":"SaladUI.Switch.html#switch/1","title":"SaladUI.Switch.switch/1","type":"function"},{"doc":"* `:id` - The id to be applied to the input element\n  * `:name` - The name to be applied to the input element\n  * `:class` - Additional CSS classes\n  * `:value` - The current value of the switch\n  * `:default-value` - The default value of the switch\n  * `:field` - Phoenix form field\n  * `:disabled` - Whether the switch is disabled\n  * `:on-checked-changed` - Handler for value change event","ref":"SaladUI.Switch.html#switch/1-props","title":"Props - SaladUI.Switch.switch/1","type":"function"},{"doc":"* `id` (`:string`) - Defaults to `nil`.\n* `name` (`:string`) - Defaults to `nil`.\n* `class` (`:string`) - Defaults to `nil`.\n* `checked` (`:boolean`) - Defaults to `false`.\n* `disabled` (`:boolean`) - Defaults to `false`.\n* `on-checked-changed` (`:any`) - Handler for value change event. Defaults to `nil`.\n* `field` (`Phoenix.HTML.FormField`) - a form field struct retrieved from the form, for example: @form[:active].\n* Global attributes are accepted.","ref":"SaladUI.Switch.html#switch/1-attributes","title":"Attributes - SaladUI.Switch.switch/1","type":"function"},{"doc":"Implementation of table components from https://ui.shadcn.com/docs/components/table\nwith proper ARIA attributes for accessibility.","ref":"SaladUI.Table.html","title":"SaladUI.Table","type":"module"},{"doc":"<.table aria-label=\"Invoices\">\n       <.table_caption>A list of your recent invoices.</.table_caption>\n       <.table_header>\n         <.table_row>\n           <.table_head class=\"w-[100px]\">Invoice</.table_head>\n           <.table_head>Status</.table_head>\n           <.table_head>Method</.table_head>\n           <.table_head class=\"text-right\">Amount</.table_head>\n         </.table_row>\n       </.table_header>\n       <.table_body>\n         <.table_row :for={invoice <- @invoices}>\n           <.table_cell class=\"font-medium\"><%= invoice.number %></.table_cell>\n           <.table_cell><%= invoice.status %></.table_cell>\n           <.table_cell><%= invoice.method %></.table_cell>\n           <.table_cell class=\"text-right\"><%= invoice.amount %></.table_cell>\n         </.table_row>\n       </.table_body>\n    </.table>","ref":"SaladUI.Table.html#module-examples","title":"Examples: - SaladUI.Table","type":"module"},{"doc":"Renders a data table.","ref":"SaladUI.Table.html#table/1","title":"SaladUI.Table.table/1","type":"function"},{"doc":"* `:class` - Additional CSS classes for the table\n* `:aria-label` - Accessible name for the table when no caption is present\n* `:aria-describedby` - ID of an element that describes the table","ref":"SaladUI.Table.html#table/1-attributes","title":"Attributes - SaladUI.Table.table/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* `aria-label` (`:string`) - Defaults to `nil`.\n* `aria-describedby` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Table.html#table/1-attributes","title":"Attributes - SaladUI.Table.table/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Table.html#table/1-slots","title":"Slots - SaladUI.Table.table/1","type":"function"},{"doc":"Renders the table body.","ref":"SaladUI.Table.html#table_body/1","title":"SaladUI.Table.table_body/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Table.html#table_body/1-attributes","title":"Attributes - SaladUI.Table.table_body/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Table.html#table_body/1-slots","title":"Slots - SaladUI.Table.table_body/1","type":"function"},{"doc":"Renders a table caption.\n\nA caption provides an accessible name for the table.","ref":"SaladUI.Table.html#table_caption/1","title":"SaladUI.Table.table_caption/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Table.html#table_caption/1-attributes","title":"Attributes - SaladUI.Table.table_caption/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Table.html#table_caption/1-slots","title":"Slots - SaladUI.Table.table_caption/1","type":"function"},{"doc":"Renders a table data cell.","ref":"SaladUI.Table.html#table_cell/1","title":"SaladUI.Table.table_cell/1","type":"function"},{"doc":"* `:class` - Additional CSS classes","ref":"SaladUI.Table.html#table_cell/1-attributes","title":"Attributes - SaladUI.Table.table_cell/1","type":"function"},{"doc":"* `class` (`:any`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Table.html#table_cell/1-attributes","title":"Attributes - SaladUI.Table.table_cell/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Table.html#table_cell/1-slots","title":"Slots - SaladUI.Table.table_cell/1","type":"function"},{"doc":"Renders a table footer.","ref":"SaladUI.Table.html#table_footer/1","title":"SaladUI.Table.table_footer/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted. Supports all globals plus: `[\"disabled\", \"form\", \"name\", \"value\"]`.","ref":"SaladUI.Table.html#table_footer/1-attributes","title":"Attributes - SaladUI.Table.table_footer/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Table.html#table_footer/1-slots","title":"Slots - SaladUI.Table.table_footer/1","type":"function"},{"doc":"Renders a table column header.","ref":"SaladUI.Table.html#table_head/1","title":"SaladUI.Table.table_head/1","type":"function"},{"doc":"* `:class` - Additional CSS classes\n* `:scope` - Scope of the header cell (default: \"col\")\n* `:aria-sort` - Sort direction for screen readers (ascending, descending, or none)","ref":"SaladUI.Table.html#table_head/1-attributes","title":"Attributes - SaladUI.Table.table_head/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* `scope` (`:string`) - Defaults to `\"col\"`.\n* `aria-sort` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Table.html#table_head/1-attributes","title":"Attributes - SaladUI.Table.table_head/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Table.html#table_head/1-slots","title":"Slots - SaladUI.Table.table_head/1","type":"function"},{"doc":"Renders the table header container.","ref":"SaladUI.Table.html#table_header/1","title":"SaladUI.Table.table_header/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Table.html#table_header/1-attributes","title":"Attributes - SaladUI.Table.table_header/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Table.html#table_header/1-slots","title":"Slots - SaladUI.Table.table_header/1","type":"function"},{"doc":"Renders a table row.","ref":"SaladUI.Table.html#table_row/1","title":"SaladUI.Table.table_row/1","type":"function"},{"doc":"* `:class` - Additional CSS classes\n* `:aria-rowindex` - Numeric index of the row","ref":"SaladUI.Table.html#table_row/1-attributes","title":"Attributes - SaladUI.Table.table_row/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* `aria-rowindex` (`:integer`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Table.html#table_row/1-attributes","title":"Attributes - SaladUI.Table.table_row/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Table.html#table_row/1-slots","title":"Slots - SaladUI.Table.table_row/1","type":"function"},{"doc":"Implementation of tabs components from https://ui.shadcn.com/docs/components/tabs","ref":"SaladUI.Tabs.html","title":"SaladUI.Tabs","type":"module"},{"doc":"<.tabs id=\"settings\" default=\"account\" on_tab_changed={JS.push(\"tab_changed\")}>\n      <.tabs_list>\n        <.tabs_trigger value=\"account\">Account</.tabs_trigger>\n        <.tabs_trigger value=\"password\">Password</.tabs_trigger>\n      </.tabs_list>\n      <.tabs_content value=\"account\">\n        <.card>\n          <.card_content class=\"p-6\">\n            Account settings go here\n          </.card_content>\n        </.card>\n      </.tabs_content>\n      <.tabs_content value=\"password\">\n        <.card>\n          <.card_content class=\"p-6\">\n            Password settings go here\n          </.card_content>\n        </.card>\n      </.tabs_content>\n    </.tabs>","ref":"SaladUI.Tabs.html#module-example","title":"Example: - SaladUI.Tabs","type":"module"},{"doc":"Primary tabs component that serves as a container for tab triggers and content.","ref":"SaladUI.Tabs.html#tabs/1","title":"SaladUI.Tabs.tabs/1","type":"function"},{"doc":"* `id` (`:string`) (required) - Unique identifier for the tabs component.\n* `default` (`:string`) - Default selected tab value. Defaults to `nil`.\n* `class` (`:string`) - Defaults to `nil`.\n* `on-tab-changed` (`:any`) - Handler for tab change events. Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Tabs.html#tabs/1-attributes","title":"Attributes - SaladUI.Tabs.tabs/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Tabs.html#tabs/1-slots","title":"Slots - SaladUI.Tabs.tabs/1","type":"function"},{"doc":"Content panel that corresponds to a tab trigger.","ref":"SaladUI.Tabs.html#tabs_content/1","title":"SaladUI.Tabs.tabs_content/1","type":"function"},{"doc":"* `value` (`:string`) (required) - Value that matches a tab trigger.\n* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Tabs.html#tabs_content/1-attributes","title":"Attributes - SaladUI.Tabs.tabs_content/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Tabs.html#tabs_content/1-slots","title":"Slots - SaladUI.Tabs.tabs_content/1","type":"function"},{"doc":"Container for tab triggers that provides proper styling and ARIA attributes.","ref":"SaladUI.Tabs.html#tabs_list/1","title":"SaladUI.Tabs.tabs_list/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Tabs.html#tabs_list/1-attributes","title":"Attributes - SaladUI.Tabs.tabs_list/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Tabs.html#tabs_list/1-slots","title":"Slots - SaladUI.Tabs.tabs_list/1","type":"function"},{"doc":"Individual tab button that activates its corresponding content panel.","ref":"SaladUI.Tabs.html#tabs_trigger/1","title":"SaladUI.Tabs.tabs_trigger/1","type":"function"},{"doc":"* `value` (`:string`) (required) - Unique value that identifies this tab.\n* `class` (`:string`) - Defaults to `nil`.\n* `disabled` (`:boolean`) - Defaults to `false`.\n* Global attributes are accepted.","ref":"SaladUI.Tabs.html#tabs_trigger/1-attributes","title":"Attributes - SaladUI.Tabs.tabs_trigger/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Tabs.html#tabs_trigger/1-slots","title":"Slots - SaladUI.Tabs.tabs_trigger/1","type":"function"},{"doc":"Implementation of a textarea component for multi-line text input.","ref":"SaladUI.Textarea.html","title":"SaladUI.Textarea","type":"module"},{"doc":"<.textarea field={f[:description]} placeholder=\"Type your message here\" />\n    <.textarea rows=\"6\" placeholder=\"Add your comments\" value={@description} />","ref":"SaladUI.Textarea.html#module-examples","title":"Examples: - SaladUI.Textarea","type":"module"},{"doc":"Renders a form textarea.","ref":"SaladUI.Textarea.html#textarea/1","title":"SaladUI.Textarea.textarea/1","type":"function"},{"doc":"* `:id` - The id to use for the textarea\n* `:name` - The name to use for the textarea\n* `:value` - The value to pre-populate the textarea with\n* `:field` - A form field struct to build the textarea from\n* `:class` - Additional CSS classes to apply\n* `:rows` - Number of visible text lines (passed through as rest)\n* `:placeholder` - Placeholder text (passed through as rest)\n* `:disabled` - Whether the textarea is disabled (passed through as rest)\n* `:required` - Whether the textarea is required (passed through as rest)","ref":"SaladUI.Textarea.html#textarea/1-options","title":"Options - SaladUI.Textarea.textarea/1","type":"function"},{"doc":"* `id` (`:any`) - Defaults to `nil`.\n* `name` (`:any`) - Defaults to `nil`.\n* `value` (`:any`)\n* `field` (`Phoenix.HTML.FormField`) - a form field struct retrieved from the form, for example: @form[:email].\n* `class` (`:any`) - Defaults to `nil`.\n* Global attributes are accepted. Supports all globals plus: `[\"disabled\", \"form\", \"rows\", \"cols\"]`.","ref":"SaladUI.Textarea.html#textarea/1-attributes","title":"Attributes - SaladUI.Textarea.textarea/1","type":"function"},{"doc":"Implementation of Tooltip component for SaladUI framework.\n\nTooltips provide additional information about an element when hovering over it.","ref":"SaladUI.Tooltip.html","title":"SaladUI.Tooltip","type":"module"},{"doc":"<.tooltip id=\"help-tooltip\">\n      <.tooltip_trigger>\n        <.button variant=\"ghost\" size=\"icon\">\n           \n              \n              \n              \n           \n        </.button>\n      </.tooltip_trigger>\n      <.tooltip_content side=\"top\" align=\"center\">\n        Need help? Click here for more information.\n      </.tooltip_content>\n    </.tooltip>","ref":"SaladUI.Tooltip.html#module-examples","title":"Examples: - SaladUI.Tooltip","type":"module"},{"doc":"The main tooltip component that manages state and positioning.","ref":"SaladUI.Tooltip.html#tooltip/1","title":"SaladUI.Tooltip.tooltip/1","type":"function"},{"doc":"* `:id` - Unique identifier for the tooltip (optional, auto-generated if not provided).\n* `:open-delay` - Delay in milliseconds before opening the tooltip. Defaults to `150`.\n* `:close-delay` - Delay in milliseconds before closing the tooltip. Defaults to `100`.\n* `:on-open` - Handler for tooltip open event.\n* `:on-close` - Handler for tooltip close event.\n* `:class` - Additional CSS classes.","ref":"SaladUI.Tooltip.html#tooltip/1-options","title":"Options - SaladUI.Tooltip.tooltip/1","type":"function"},{"doc":"* `id` (`:string`) - Defaults to `nil`.\n* `open-delay` (`:integer`) - Delay in milliseconds before opening the tooltip. Defaults to `150`.\n* `close-delay` (`:integer`) - Delay in milliseconds before closing the tooltip. Defaults to `100`.\n* `on-open` (`:any`) - Handler for tooltip open event. Defaults to `nil`.\n* `on-close` (`:any`) - Handler for tooltip close event. Defaults to `nil`.\n* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Tooltip.html#tooltip/1-attributes","title":"Attributes - SaladUI.Tooltip.tooltip/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Tooltip.html#tooltip/1-slots","title":"Slots - SaladUI.Tooltip.tooltip/1","type":"function"},{"doc":"The tooltip content that appears when triggered.","ref":"SaladUI.Tooltip.html#tooltip_content/1","title":"SaladUI.Tooltip.tooltip_content/1","type":"function"},{"doc":"* `:side` - Placement of the tooltip relative to the trigger (top, right, bottom, left). Defaults to `\"top\"`.\n* `:align` - Alignment of the tooltip (start, center, end). Defaults to `\"center\"`.\n* `:side-offset` - Distance from the trigger in pixels. Defaults to `4`.\n* `:align-offset` - Offset along the alignment axis. Defaults to `0`.\n* `:class` - Additional CSS classes.","ref":"SaladUI.Tooltip.html#tooltip_content/1-options","title":"Options - SaladUI.Tooltip.tooltip_content/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* `side` (`:string`) - Defaults to `\"top\"`.\n* `align` (`:string`) - Defaults to `\"center\"`.\n* `side-offset` (`:integer`) - Distance from the trigger in pixels. Defaults to `8`.\n* `align-offset` (`:integer`) - Offset along the alignment axis. Defaults to `0`.\n* Global attributes are accepted.","ref":"SaladUI.Tooltip.html#tooltip_content/1-attributes","title":"Attributes - SaladUI.Tooltip.tooltip_content/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Tooltip.html#tooltip_content/1-slots","title":"Slots - SaladUI.Tooltip.tooltip_content/1","type":"function"},{"doc":"The trigger element that activates the tooltip when hovered.\n\nIf not provided, the first child of the tooltip will be used as trigger.","ref":"SaladUI.Tooltip.html#tooltip_trigger/1","title":"SaladUI.Tooltip.tooltip_trigger/1","type":"function"},{"doc":"* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"SaladUI.Tooltip.html#tooltip_trigger/1-attributes","title":"Attributes - SaladUI.Tooltip.tooltip_trigger/1","type":"function"},{"doc":"* `inner_block` (required)","ref":"SaladUI.Tooltip.html#tooltip_trigger/1-slots","title":"Slots - SaladUI.Tooltip.tooltip_trigger/1","type":"function"},{"doc":"A collection of Live View components inspired by shadcn\n \n\n \n     Demo  |\n     Documentation  |\n     Support project \n \n  \n\n \n \n   \n   \n   \n   \n \n\n![Demo admin](./docs/images/demo.gif)","ref":"readme.html","title":"README","type":"extras"},{"doc":"## [Demo storybook v1](https://salad-storybook.fly.dev/)","ref":"readme.html#v1-is-now-beta-release","title":"🚧 V1 is now beta release - README","type":"extras"},{"doc":"1. Add `salad_ui` to your `mix.exs`\n\n```elixir\ndef deps do\n  [\n    {:salad_ui, \"~> 1.0.0-beta.2\"},\n  ]\nend\n```\n\n2. Choose your installation method:","ref":"readme.html#installation","title":"Installation - README","type":"extras"},{"doc":"For a quick start with minimal configuration:\n\n```bash\nmix salad.setup\n```\n\nThis sets up SaladUI to use components directly from the library. You can start using components immediately:\n\n```elixir\ndefmodule MyAppWeb.PageLive do\n  use MyAppWeb, :live_view\n  import SaladUI.Button\n  import SaladUI.Dialog\n\n  def render(_) do\n    ~H\"\"\"\n    <.button>Click me</.button>\n    <.dialog id=\"my-dialog\">\n      <.dialog_content>\n         Hello world! \n      </.dialog_content>\n    </.dialog>\n    \"\"\"\n  end\nend\n```","ref":"readme.html#method-1-quick-setup-using-as-library","title":"Method 1: Quick Setup (Using as Library) - README","type":"extras"},{"doc":"For full customization with local component files:\n\n```bash\n# Default installation\nmix salad.install\n\n# With custom prefix and color scheme\nmix salad.install --prefix MyUI --color-scheme slate\n```\n\nThis copies all component files to your project under `lib/my_app_web/components/ui/` where you can customize them:\n\n```elixir\ndefmodule MyAppWeb.PageLive do\n  use MyAppWeb, :live_view\n  import MyAppWeb.Components.UI.Button\n  import MyAppWeb.Components.UI.Dialog\n\n  def render(_) do\n    ~H\"\"\"\n    <.button>Click me</.button>\n    <.dialog id=\"my-dialog\">\n      <.dialog_content>\n         Hello world! \n      </.dialog_content>\n    </.dialog>\n    \"\"\"\n  end\nend\n```","ref":"readme.html#method-2-local-installation-customizable","title":"Method 2: Local Installation (Customizable) - README","type":"extras"},{"doc":"### `mix salad.setup`\n- ✅ Sets up Tailwind CSS and color schemes\n- ✅ Configures JavaScript hooks and components\n- ✅ Ready to use immediately\n- ❌ Components cannot be customized\n- ❌ Uses external package dependencies\n\n### `mix salad.install`\n- ✅ Sets up Tailwind CSS and color schemes\n- ✅ Copies all component source code locally\n- ✅ Copies all JavaScript files locally\n- ✅ Full customization possible\n- ✅ No external runtime dependencies\n- ✅ Custom module prefixes","ref":"readme.html#what-each-method-does","title":"What Each Method Does - README","type":"extras"},{"doc":"1. Custom error translate function\n\n```elixir\nconfig :salad_ui, :error_translator_function, {MyAppWeb.CoreComponents, :translate_error}\n```","ref":"readme.html#more-configuration","title":"More configuration - README","type":"extras"},{"doc":"Here is how to start develop SaladUI on local machine.\n\n1. Clone this repo\n2. Go into storybook folder\n3. Start storybook\n\n```\ncd storybook\nmix phx.server\n```","ref":"readme.html#development","title":"🛠️ Development - README","type":"extras"},{"doc":"All v1 component are not covered by UnitTest. Currently I'm working on an important project so I don't have much time for this. If you're interested in this project, please help to add Unit Test if possible. 🙏","ref":"readme.html#unit-testing","title":"Unit Testing - README","type":"extras"},{"doc":"| Component      | v0   | v1   |\n|----------------|------|------|\n| Accordion      | ✅    | ✅    |\n| Alert          | ✅    | ✅     |\n| Alert Dialog   | ✅    | ✅    |\n| Avatar         | ✅    | ✅     |\n| Badge          | ✅    | ✅     |\n| Breadcrumb     | ✅    | ✅     |\n| Button         | ✅    | ✅     |\n| Card           | ✅    | ✅     |\n| Carousel       | ❌    |      |\n| Checkbox       | ✅    | ✅     |\n| Collapsible    | ✅    | ✅    |\n| Combobox       | ❌    |      |\n| Command        | ❌    | ✅ [@ilyabayel](https://github.com/ilyabayel)     |\n| Context Menu   | ❌    |      |\n| Dialog         | ✅    | ✅     |\n| Drawer         | ❌    |      |\n| Dropdown Menu  | ✅    | ✅     |\n| Form           | ✅    | ✅     |\n| Hover Card     | ✅    | ✅      |\n| Input          | ✅    | ✅     |\n| Input OTP      | ❌    |      |\n| Label          | ✅    | ✅      |\n| Pagination     | ✅    | ✅     |\n| Popover        | ✅    | ✅     |\n| Progress       | ✅    | ✅    |\n| Radio Group    | ✅    | ✅     |\n| Scroll Area    | ✅    | ✅    |\n| Select         | ✅    | ✅     |\n| Separator      | ✅    | ✅     |\n| Sheet          | ✅    | ✅     |\n| Skeleton       | ✅    | ✅     |\n| Slider         | ✅    | ✅     |\n| Switch         | ✅    | ✅   |\n| Table          | ✅    | ✅    |\n| Tabs           | ✅    | ✅     |\n| Textarea       | ✅    | ✅     |\n| Tooltip        | ✅    | ✅    |","ref":"readme.html#list-of-components","title":"List of components - README","type":"extras"},{"doc":"","ref":"readme.html#contributors","title":"🌟 Contributors - README","type":"extras"},{"doc":"This project could not be available without these awesome works:\n\n- `tailwind css` an awesome css utility project\n- `turboprop` I borrow code from here for merging tailwinds classes\n- `shadcn/ui` which this project is inspired from\n- `Phoenix Framework` of course","ref":"readme.html#credits","title":"😘 Credits - README","type":"extras"},{"doc":"# Quick Simple Component Guide\n\nSimple components display data with minimal interaction. Follow these 4 steps:","ref":"implement_simple_component.html","title":"Quick Simple Component Guide","type":"extras"},{"doc":"```elixir\ndefmodule SaladUI.MyComponent do\n  use SaladUI, :component\n\n  attr :id, :string, required: true\n  attr :data, :any, required: true\n\n  def my_component(assigns) do\n    ~H\"\"\"\n     \n      <!-- Your HTML here -->\n     \n    \"\"\"\n  end\nend\n```","ref":"implement_simple_component.html#step-1-create-elixir-component","title":"Step 1: Create Elixir Component - Quick Simple Component Guide","type":"extras"},{"doc":"```javascript\nimport Component from \"../core/component\";\nimport SaladUI from \"../index\";\n\nclass MyComponent extends Component {\n  constructor(el, hookContext) {\n    super(el, { hookContext });\n    this.data = JSON.parse(this.el.dataset.options).data;\n    this.initialize();\n  }\n\n  getComponentConfig() {\n    return {\n      stateMachine: {\n        idle: { transitions: { update: \"idle\" } }\n      }\n    };\n  }\n\n  initialize() {\n    // Initialize your component\n    console.log(\"Data:\", this.data);\n  }\n\n  handleCommand(command, params) {\n    if (command === \"update\") {\n      this.data = params.data;\n      this.initialize();\n      return true;\n    }\n    return super.handleCommand(command, params);\n  }\n\n  destroy() {\n    // Cleanup here\n  }\n}\n\nSaladUI.register(\"my-component\", MyComponent);\nexport default MyComponent;\n```","ref":"implement_simple_component.html#step-2-create-javascript-component","title":"Step 2: Create JavaScript Component - Quick Simple Component Guide","type":"extras"},{"doc":"In `lib/salad_ui.ex`:\n```elixir\nimport SaladUI.MyComponent\n```\n\nIn `assets/js/app.js`:\n```javascript\nimport \"./salad_ui/components/my-component\";\n```","ref":"implement_simple_component.html#step-3-add-import","title":"Step 3: Add Import - Quick Simple Component Guide","type":"extras"},{"doc":"```heex\n<.my_component id=\"example\" data={%{value: 123}} />\n```","ref":"implement_simple_component.html#step-4-use-component","title":"Step 4: Use Component - Quick Simple Component Guide","type":"extras"},{"doc":"","ref":"implement_simple_component.html#chart-example","title":"Chart Example - Quick Simple Component Guide","type":"extras"},{"doc":"```elixir\ndefmodule SaladUI.Chart do\n  use SaladUI, :component\n\n  attr :id, :string, required: true\n  attr :\"chart-data\", :map, required: true\n\n  def chart(assigns) do\n    ~H\"\"\"\n     \n     \n    \"\"\"\n  end\nend\n```","ref":"implement_simple_component.html#elixir","title":"Elixir: - Quick Simple Component Guide","type":"extras"},{"doc":"```javascript\nimport Component from \"../core/component\";\nimport SaladUI from \"../index\";\nimport Chart from \"chart.js/auto\";\n\nclass ChartComponent extends Component {\n  constructor(el, hookContext) {\n    super(el, { hookContext });\n    this.initChart();\n  }\n\n  getComponentConfig() {\n    return {\n      stateMachine: {\n        idle: { transitions: { update: \"idle\" } }\n      }\n    };\n  }\n\n  initChart() {\n    const data = JSON.parse(this.el.dataset.chartData);\n    this.chart = new Chart(this.el, {\n      type: \"line\",\n      data: data\n    });\n  }\n\n  handleCommand(command, params) {\n    if (command === \"update\") {\n      this.chart.data = params.data;\n      this.chart.update();\n      return true;\n    }\n  }\n\n  destroy() {\n    this.chart?.destroy();\n  }\n}\n\nSaladUI.register(\"chart\", ChartComponent);\n```","ref":"implement_simple_component.html#javascript","title":"JavaScript: - Quick Simple Component Guide","type":"extras"},{"doc":"```heex\n<.chart\n  id=\"sales-chart\"\n  chart-data={%{\n    labels: [\"Jan\", \"Feb\", \"Mar\"],\n    datasets: [%{\n      label: \"Sales\",\n      data: [10, 20, 30]\n    }]\n  }}\n/>\n```","ref":"implement_simple_component.html#usage","title":"Usage: - Quick Simple Component Guide","type":"extras"},{"doc":"1. **`phx-hook=\"SaladUI\"`** - Required\n2. **`data-component=\"name\"`** - Component identifier, match with component name registered with SaladUI\n3. **`data-part=\"root\"`** - On main element\n4. **`SaladUI.register()`** - Register component\n5. **`getComponentConfig()`** - Return state machine config\n\nThat's it! Simple components just need these basics.","ref":"implement_simple_component.html#key-requirements","title":"Key Requirements - Quick Simple Component Guide","type":"extras"},{"doc":"# Quick Complex Component Guide\n\nComplex components have multiple parts, states, and interactions. Follow this pattern:","ref":"complex_component_guide.html","title":"Quick Complex Component Guide","type":"extras"},{"doc":"```elixir\ndefmodule SaladUI.Dialog do\n  use SaladUI, :component\n\n  # Main container\n  attr :id, :string, required: true\n  attr :open, :boolean, default: false\n  attr :\"on-open\", :any, default: nil\n  attr :\"on-close\", :any, default: nil\n  slot :inner_block, required: true\n\n  def dialog(assigns) do\n    event_map = %{}\n    |> add_event_mapping(assigns, \"opened\", :\"on-open\")\n    |> add_event_mapping(assigns, \"closed\", :\"on-close\")\n\n    assigns = assign(assigns, :event_map, json(event_map))\n\n    ~H\"\"\"\n     \n      {render_slot(@inner_block)}\n     \n    \"\"\"\n  end\n\n  # Trigger element\n  def dialog_trigger(assigns) do\n    ~H\"\"\"\n     \n      {render_slot(@inner_block)}\n     \n    \"\"\"\n  end\n\n  # Content element\n  def dialog_content(assigns) do\n    ~H\"\"\"\n     \n        \n       \n        {render_slot(@inner_block)}\n         × \n       \n     \n    \"\"\"\n  end\nend\n```","ref":"complex_component_guide.html#step-1-create-elixir-component","title":"Step 1: Create Elixir Component - Quick Complex Component Guide","type":"extras"},{"doc":"```javascript\nimport Component from \"../core/component\";\nimport SaladUI from \"../index\";\nimport FocusTrap from \"../core/focus-trap\";\n\nclass DialogComponent extends Component {\n  constructor(el, hookContext) {\n    super(el, { hookContext });\n    this.content = this.getPart(\"content\");\n    this.contentPanel = this.getPart(\"content-panel\");\n  }\n\n  getComponentConfig() {\n    return {\n      // State machine\n      stateMachine: {\n        closed: {\n          enter: \"onClosedEnter\",\n          transitions: { open: \"open\" }\n        },\n        open: {\n          enter: \"onOpenEnter\",\n          transitions: { close: \"closed\" }\n        }\n      },\n\n      // Events by state\n      events: {\n        closed: {\n          mouseMap: {\n            trigger: { click: \"open\" }\n          }\n        },\n        open: {\n          mouseMap: {\n            \"close-trigger\": { click: \"close\" },\n            overlay: { click: \"close\" }\n          },\n          keyMap: {\n            Escape: \"close\"\n          }\n        }\n      },\n\n      // Visibility control\n      hiddenConfig: {\n        closed: { content: true },\n        open: { content: false }\n      },\n\n      // Accessibility\n      ariaConfig: {\n        trigger: {\n          all: { haspopup: \"dialog\" },\n          open: { expanded: \"true\" },\n          closed: { expanded: \"false\" }\n        },\n        content: {\n          all: { role: \"dialog\" }\n        }\n      }\n    };\n  }\n\n  // State handlers\n  onOpenEnter() {\n    if (!this.focusTrap) {\n      this.focusTrap = new FocusTrap(this.contentPanel);\n    }\n    this.focusTrap.activate();\n    this.pushEvent(\"opened\");\n  }\n\n  onClosedEnter() {\n    this.focusTrap?.deactivate();\n    this.pushEvent(\"closed\");\n  }\n\n  beforeDestroy() {\n    this.focusTrap?.destroy();\n  }\n}\n\nSaladUI.register(\"dialog\", DialogComponent);\n```","ref":"complex_component_guide.html#step-2-create-javascript-component","title":"Step 2: Create JavaScript Component - Quick Complex Component Guide","type":"extras"},{"doc":"```heex\n<.dialog id=\"my-dialog\" on-open={JS.push(\"dialog_opened\")}>\n  <.dialog_trigger>\n    <.button>Open Dialog</.button>\n  </.dialog_trigger>\n  <.dialog_content>\n     Dialog Title \n     Dialog content here. \n  </.dialog_content>\n</.dialog>\n```","ref":"complex_component_guide.html#step-3-usage","title":"Step 3: Usage - Quick Complex Component Guide","type":"extras"},{"doc":"","ref":"complex_component_guide.html#key-complex-component-elements","title":"Key Complex Component Elements - Quick Complex Component Guide","type":"extras"},{"doc":"```elixir\ndata-part=\"root\"          # Main container\ndata-part=\"trigger\"       # Opens the component\ndata-part=\"content\"       # Main content area\ndata-part=\"close-trigger\" # Closes the component\n```","ref":"complex_component_guide.html#multiple-parts","title":"Multiple Parts - Quick Complex Component Guide","type":"extras"},{"doc":"```elixir\ndata-action=\"open\"   # Triggers open transition\ndata-action=\"close\"  # Triggers close transition\ndata-action=\"toggle\" # Toggles between states\n```","ref":"complex_component_guide.html#actions","title":"Actions - Quick Complex Component Guide","type":"extras"},{"doc":"```javascript\nstateMachine: {\n  state1: {\n    enter: \"onState1Enter\",        // Called when entering state\n    exit: \"onState1Exit\",          // Called when leaving state\n    transitions: {\n      event: \"state2\"              // event -> new state\n    }\n  }\n}\n```","ref":"complex_component_guide.html#state-machine-pattern","title":"State Machine Pattern - Quick Complex Component Guide","type":"extras"},{"doc":"```javascript\nevents: {\n  stateName: {\n    mouseMap: {\n      partName: { eventType: \"action\" }\n    },\n    keyMap: {\n      KeyName: \"action\"\n    }\n  }\n}\n```","ref":"complex_component_guide.html#event-handling","title":"Event Handling - Quick Complex Component Guide","type":"extras"},{"doc":"```elixir\n# In template\ndata-event-mappings={json(%{\"opened\" => assigns[:\"on-open\"]})}\n```\n\n```javascript\n// In JavaScript\nthis.pushEvent(\"opened\", { data: value });\n```","ref":"complex_component_guide.html#server-communication","title":"Server Communication - Quick Complex Component Guide","type":"extras"},{"doc":"","ref":"complex_component_guide.html#common-complex-patterns","title":"Common Complex Patterns - Quick Complex Component Guide","type":"extras"},{"doc":"- **Parts**: trigger, content, item\n- **States**: closed, open\n- **Features**: positioning, keyboard navigation","ref":"complex_component_guide.html#dropdown-select","title":"Dropdown/Select - Quick Complex Component Guide","type":"extras"},{"doc":"- **Parts**: list, trigger, content\n- **States**: per tab (active/inactive)\n- **Features**: keyboard navigation, ARIA","ref":"complex_component_guide.html#tabs","title":"Tabs - Quick Complex Component Guide","type":"extras"},{"doc":"- **Parts**: item, trigger, content\n- **States**: collapsed, expanded\n- **Features**: single/multiple open","ref":"complex_component_guide.html#accordion","title":"Accordion - Quick Complex Component Guide","type":"extras"},{"doc":"- **Parts**: trigger, content, overlay\n- **States**: closed, open\n- **Features**: focus trap, click outside\n\nComplex components follow this pattern but scale up with more parts, states, and interactions.","ref":"complex_component_guide.html#modal-sheet","title":"Modal/Sheet - Quick Complex Component Guide","type":"extras"},{"doc":"# SaladUI Component Configuration Reference\n\nThis document defines the configuration structure for SaladUI components returned by `getComponentConfig()`.","ref":"component_config_guide.html","title":"SaladUI Component Configuration Reference","type":"extras"},{"doc":"```js\ngetComponentConfig() {\n  return {\n    stateMachine: { /* State definitions and transitions */ },\n    events: { /* Event handlers by state */ },\n    hiddenConfig: { /* Visibility control by state */ },\n    ariaConfig: { /* ARIA attributes by part and state */ }\n  };\n}\n```","ref":"component_config_guide.html#overview","title":"Overview - SaladUI Component Configuration Reference","type":"extras"},{"doc":"Defines component states, transitions, and lifecycle handlers.","ref":"component_config_guide.html#state-machine-configuration","title":"State Machine Configuration - SaladUI Component Configuration Reference","type":"extras"},{"doc":"```js\nstateMachine: {\n  stateName: {\n    enter: \"handlerMethod\" | handlerFunction,    // Called when entering state\n    exit: \"handlerMethod\" | handlerFunction,     // Called when leaving state\n    transitions: {\n      eventName: \"targetState\" | transitionFunction\n    }\n  }\n}\n```","ref":"component_config_guide.html#structure","title":"Structure - SaladUI Component Configuration Reference","type":"extras"},{"doc":"```js\nstateMachine: {\n  closed: {\n    enter: \"onClosedEnter\",\n    exit: \"onClosedExit\",\n    transitions: {\n      open: \"open\",\n      toggle: \"open\"\n    }\n  },\n  open: {\n    enter: \"onOpenEnter\",\n    transitions: {\n      close: \"closed\",\n      toggle: \"closed\"\n    }\n  },\n  loading: {\n    enter: () => console.log(\"Loading started\"),\n    transitions: {\n      complete: \"idle\",\n      error: \"error\"\n    }\n  }\n}\n```","ref":"component_config_guide.html#example","title":"Example - SaladUI Component Configuration Reference","type":"extras"},{"doc":"```js\n// Method referenced by string\nonOpenEnter(params) {\n  console.log(\"Dialog opened with\", params);\n  this.pushEvent(\"opened\");\n}\n\n// Inline function\nenter: (params) => {\n  this.setupComponent(params);\n}\n```","ref":"component_config_guide.html#state-handler-methods","title":"State Handler Methods - SaladUI Component Configuration Reference","type":"extras"},{"doc":"```js\ntransitions: {\n  // Simple transition\n  open: \"open\",\n\n  // Conditional transition\n  toggle: (params) => {\n    return this.state === \"open\" ? \"closed\" : \"open\";\n  },\n\n  // Complex transition logic\n  submit: (params) => {\n    if (params.isValid) {\n      return \"success\";\n    } else {\n      return \"error\";\n    }\n  }\n}\n```","ref":"component_config_guide.html#transition-functions","title":"Transition Functions - SaladUI Component Configuration Reference","type":"extras"},{"doc":"Defines event handlers for different states, organized by event type and target part.","ref":"component_config_guide.html#events-configuration","title":"Events Configuration - SaladUI Component Configuration Reference","type":"extras"},{"doc":"```js\nevents: {\n  stateName: {\n    mouseMap: {\n      partName: {\n        eventType: \"action\" | handlerFunction\n      }\n    },\n    keyMap: {\n      keyName: \"action\" | handlerFunction\n    },\n    keyEventTarget: \"partName\"  // Optional: which part receives key events\n  },\n  _all: {  // Special state: applies to all states\n    // Event handlers that work in any state\n  }\n}\n```","ref":"component_config_guide.html#structure","title":"Structure - SaladUI Component Configuration Reference","type":"extras"},{"doc":"```js\nevents: {\n  closed: {\n    mouseMap: {\n      trigger: {\n        click: \"open\",                    // Trigger transition\n        mouseenter: \"handleMouseEnter\",   // Call method\n        mouseleave: (event) => {          // Inline function\n          this.clearHover();\n        }\n      },\n      \"menu-item\": {\n        click: \"selectItem\",\n        mouseenter: \"highlightItem\"\n      }\n    }\n  },\n  open: {\n    mouseMap: {\n      overlay: { click: \"close\" },\n      \"close-button\": { click: \"close\" },\n      content: {\n        click: (event) => event.stopPropagation()\n      }\n    }\n  }\n}\n```","ref":"component_config_guide.html#mouse-events","title":"Mouse Events - SaladUI Component Configuration Reference","type":"extras"},{"doc":"```js\nevents: {\n  open: {\n    keyEventTarget: \"content\",  // Keys are listened on content part\n    keyMap: {\n      Escape: \"close\",\n      Enter: \"confirm\",\n      ArrowDown: () => this.navigateNext(),\n      ArrowUp: () => this.navigatePrev(),\n      \" \": \"toggle\",\n      Tab: (event) => {\n        // Custom tab handling\n        this.handleTabNavigation(event);\n      }\n    }\n  },\n  _all: {\n    keyMap: {\n      \"?\": () => this.showHelp()  // Help works in any state\n    }\n  }\n}\n```","ref":"component_config_guide.html#keyboard-events","title":"Keyboard Events - SaladUI Component Configuration Reference","type":"extras"},{"doc":"Any valid `event.key` value can be used:\n\n```js\nkeyMap: {\n  \"a\": \"actionA\",\n  \"Enter\": \"confirm\",\n  \"Escape\": \"cancel\",\n  \"ArrowDown\": \"next\",\n  \" \": \"toggle\",           // Space key\n  \"F1\": \"help\",\n  \"Delete\": \"remove\",\n  \"Backspace\": \"back\",\n  \"Meta\": \"showMenu\",      // Cmd/Windows key\n  \"Control\": \"multiSelect\"\n}\n```","ref":"component_config_guide.html#key-names","title":"Key Names - SaladUI Component Configuration Reference","type":"extras"},{"doc":"Any valid DOM mouse event can be used:\n\n```js\nmouseMap: {\n  partName: {\n    \"click\": \"action\",\n    \"dblclick\": \"doubleClick\",\n    \"mousedown\": \"startDrag\",\n    \"mouseup\": \"endDrag\",\n    \"mouseenter\": \"hover\",\n    \"mouseleave\": \"unhover\",\n    \"mouseover\": \"over\",\n    \"mouseout\": \"out\",\n    \"contextmenu\": \"showContext\",\n    \"focus\": \"focused\",\n    \"blur\": \"blurred\",\n    \"focusin\": \"focusIn\",\n    \"focusout\": \"focusOut\"\n  }\n}\n```","ref":"component_config_guide.html#mouse-events","title":"Mouse Events - SaladUI Component Configuration Reference","type":"extras"},{"doc":"Controls part visibility based on component state.","ref":"component_config_guide.html#hidden-configuration","title":"Hidden Configuration - SaladUI Component Configuration Reference","type":"extras"},{"doc":"```js\nhiddenConfig: {\n  stateName: {\n    partName: boolean  // true = hidden, false = visible\n  }\n}\n```","ref":"component_config_guide.html#structure","title":"Structure - SaladUI Component Configuration Reference","type":"extras"},{"doc":"```js\nhiddenConfig: {\n  closed: {\n    content: true,        // Hide content when closed\n    overlay: true,\n    \"loading-spinner\": true\n  },\n  open: {\n    content: false,       // Show content when open\n    overlay: false,\n    \"close-button\": false\n  },\n  loading: {\n    content: true,\n    \"loading-spinner\": false,  // Show spinner when loading\n    \"error-message\": true\n  },\n  error: {\n    content: true,\n    \"loading-spinner\": true,\n    \"error-message\": false     // Show error when in error state\n  }\n}\n```","ref":"component_config_guide.html#example","title":"Example - SaladUI Component Configuration Reference","type":"extras"},{"doc":"When component transitions to a state:\n1. Gets visibility rules for that state\n2. For each part in the rules:\n   - Sets `element.hidden = true` if rule is `true`\n   - Sets `element.hidden = false` if rule is `false`\n3. Parts not mentioned in rules keep their current visibility","ref":"component_config_guide.html#how-it-works","title":"How It Works - SaladUI Component Configuration Reference","type":"extras"},{"doc":"Sets accessibility attributes on parts based on state.","ref":"component_config_guide.html#aria-configuration","title":"ARIA Configuration - SaladUI Component Configuration Reference","type":"extras"},{"doc":"```js\nariaConfig: {\n  partName: {\n    all: { attribute: \"value\" },        // Always applied\n    stateName: { attribute: \"value\" }   // Applied in specific state\n  }\n}\n```","ref":"component_config_guide.html#structure","title":"Structure - SaladUI Component Configuration Reference","type":"extras"},{"doc":"```js\nariaConfig: {\n  trigger: {\n    all: { role: \"button\", haspopup: \"dialog\" },\n    open: { expanded: \"true\" },\n    closed: { expanded: \"false\" }\n  },\n  content: {\n    all: { role: \"dialog\" },\n    open: { hidden: \"false\" },\n    closed: { hidden: \"true\" }\n  }\n}\n```","ref":"component_config_guide.html#basic-example","title":"Basic Example - SaladUI Component Configuration Reference","type":"extras"},{"doc":"```js\n// Config -> HTML\nrole: \"button\"           // -> role=\"button\"\nexpanded: \"true\"         // -> aria-expanded=\"true\"\nhidden: \"true\"           // -> aria-hidden=\"true\"\nlabelledby: \"title-id\"   // -> aria-labelledby=\"title-id\"\n```","ref":"component_config_guide.html#attribute-mapping","title":"Attribute Mapping - SaladUI Component Configuration Reference","type":"extras"},{"doc":"```js\nariaConfig: {\n  slider: {\n    all: {\n      role: \"slider\",\n      valuemin: () => this.min.toString(),\n      valuenow: () => this.value.toString()\n    }\n  }\n}\n```","ref":"component_config_guide.html#dynamic-values","title":"Dynamic Values - SaladUI Component Configuration Reference","type":"extras"},{"doc":"```js\n// Dialog\nariaConfig: {\n  trigger: {\n    all: { haspopup: \"dialog\" },\n    open: { expanded: \"true\" },\n    closed: { expanded: \"false\" }\n  },\n  content: {\n    all: { role: \"dialog\" }\n  }\n}\n\n// Menu\nariaConfig: {\n  trigger: {\n    all: { haspopup: \"menu\" },\n    open: { expanded: \"true\" }\n  },\n  content: { all: { role: \"menu\" } },\n  item: { all: { role: \"menuitem\" } }\n}\n\n// Tabs\nariaConfig: {\n  list: { all: { role: \"tablist\" } },\n  trigger: {\n    all: { role: \"tab\" },\n    active: { selected: \"true\" }\n  },\n  content: { all: { role: \"tabpanel\" } }\n}\n```","ref":"component_config_guide.html#common-patterns","title":"Common Patterns - SaladUI Component Configuration Reference","type":"extras"},{"doc":"```js\ngetComponentConfig() {\n  return {\n    stateMachine: {\n      closed: {\n        enter: \"onClosedEnter\",\n        transitions: {\n          open: \"open\",\n          toggle: \"open\"\n        }\n      },\n      open: {\n        enter: \"onOpenEnter\",\n        transitions: {\n          close: \"closed\",\n          toggle: \"closed\",\n          select: \"closed\"\n        }\n      }\n    },\n\n    events: {\n      closed: {\n        mouseMap: {\n          trigger: { click: \"open\" }\n        },\n        keyMap: {\n          Enter: \"open\",\n          \" \": \"open\",\n          ArrowDown: \"open\"\n        }\n      },\n      open: {\n        keyEventTarget: \"content\",\n        mouseMap: {\n          overlay: { click: \"close\" },\n          item: { click: \"selectItem\" }\n        },\n        keyMap: {\n          Escape: \"close\",\n          ArrowDown: () => this.navigateNext(),\n          ArrowUp: () => this.navigatePrev()\n        }\n      }\n    },\n\n    hiddenConfig: {\n      closed: {\n        content: true,\n        overlay: true\n      },\n      open: {\n        content: false,\n        overlay: false\n      }\n    },\n\n    ariaConfig: {\n      trigger: {\n        all: { haspopup: \"listbox\" },\n        open: { expanded: \"true\" },\n        closed: { expanded: \"false\" }\n      },\n      content: {\n        all: { role: \"listbox\" }\n      },\n      item: {\n        all: { role: \"option\" },\n        selected: { selected: \"true\" },\n        unselected: { selected: \"false\" }\n      }\n    }\n  };\n}\n```","ref":"component_config_guide.html#complete-example","title":"Complete Example - SaladUI Component Configuration Reference","type":"extras"},{"doc":"# SaladUI Communication Guide\n\nThis document explains how communication works between different parts of the SaladUI system: client-to-server, server-to-client, and client-to-client.","ref":"component_communications_explain.html","title":"SaladUI Communication Guide","type":"extras"},{"doc":"SaladUI uses a hybrid architecture with multiple communication channels:\n\n- **Client → Server**: JavaScript components send events to LiveView\n- **Server → Client**: LiveView sends commands to JavaScript components\n- **Client → Client**: JavaScript components communicate directly with each other","ref":"component_communications_explain.html#overview","title":"Overview - SaladUI Communication Guide","type":"extras"},{"doc":"JavaScript components send events to the Phoenix LiveView server.","ref":"component_communications_explain.html#client-server-communication","title":"Client → Server Communication - SaladUI Communication Guide","type":"extras"},{"doc":"In your Elixir component, map client events to server handlers:\n\n```elixir\ndefmodule SaladUI.Dialog do\n  def dialog(assigns) do\n    event_map = %{}\n    |> add_event_mapping(assigns, \"opened\", :\"on-open\")\n    |> add_event_mapping(assigns, \"closed\", :\"on-close\")\n    |> add_event_mapping(assigns, \"item-selected\", :\"on-item-selected\")\n\n    assigns = assign(assigns, :event_map, json(event_map))\n\n    ~H\"\"\"\n     \n      <!-- component content -->\n     \n    \"\"\"\n  end\nend\n```","ref":"component_communications_explain.html#1-event-mapping-configuration","title":"1. Event Mapping Configuration - SaladUI Communication Guide","type":"extras"},{"doc":"In your JavaScript component, use `pushEvent()` to send data to the server:\n\n```javascript\nclass DialogComponent extends Component {\n  onOpenEnter() {\n    // Send simple event\n    this.pushEvent(\"opened\");\n\n    // Send event with data\n    this.pushEvent(\"opened\", {\n      dialogId: this.el.id,\n      timestamp: Date.now()\n    });\n  }\n\n  selectItem(item) {\n    // Send structured data\n    this.pushEvent(\"item-selected\", {\n      value: item.value,\n      label: item.textContent,\n      index: this.items.indexOf(item)\n    });\n  }\n}\n```","ref":"component_communications_explain.html#2-sending-events-from-javascript","title":"2. Sending Events from JavaScript - SaladUI Communication Guide","type":"extras"},{"doc":"Handle the events in your LiveView module:\n\n```elixir\ndefmodule MyAppWeb.PageLive do\n  use MyAppWeb, :live_view\n\n  # Event handler matching the event mapping\n  def handle_event(\"dialog_opened\", params, socket) do\n    %{\"dialogId\" => dialog_id, \"timestamp\" => timestamp} = params\n\n    IO.puts(\"Dialog #{dialog_id} opened at #{timestamp}\")\n    {:noreply, socket}\n  end\n\n  def handle_event(\"item_selected\", params, socket) do\n    %{\"value\" => value, \"label\" => label} = params\n\n    socket =\n      socket\n      |> assign(:selected_item, value)\n      |> put_flash(:info, \"Selected: #{label}\")\n\n    {:noreply, socket}\n  end\nend\n```","ref":"component_communications_explain.html#3-handling-events-in-liveview","title":"3. Handling Events in LiveView - SaladUI Communication Guide","type":"extras"},{"doc":"For simple interactions, use JS commands directly in templates:\n\n```heex\n<.dialog on-open={JS.push(\"dialog_opened\")} on-close={JS.push(\"dialog_closed\")}>\n  <.dialog_trigger>\n    <.button>Open Dialog</.button>\n  </.dialog_trigger>\n  <.dialog_content>\n    <.button phx-click={JS.push(\"action_clicked\", value: %{action: \"save\"})}>\n      Save\n    </.button>\n  </.dialog_content>\n</.dialog>\n```","ref":"component_communications_explain.html#4-using-phoenix-liveview-js","title":"4. Using Phoenix.LiveView.JS - SaladUI Communication Guide","type":"extras"},{"doc":"The server sends commands to JavaScript components to control their behavior.","ref":"component_communications_explain.html#server-client-communication","title":"Server → Client Communication - SaladUI Communication Guide","type":"extras"},{"doc":"Send commands from LiveView to specific components:\n\n```elixir\ndefmodule MyAppWeb.PageLive do\n  def handle_event(\"open_dialog\", _params, socket) do\n    # Send command to component\n    socket = SaladUI.LiveView.send_command(socket, \"user-dialog\", \"open\")\n    {:noreply, socket}\n  end\n\n  def handle_event(\"update_chart\", _params, socket) do\n    new_data = get_chart_data()\n\n    # Send command with parameters\n    socket = SaladUI.LiveView.send_command(socket, \"sales-chart\", \"update\", %{\n      data: new_data,\n      options: %{animation: true}\n    })\n\n    {:noreply, socket}\n  end\n\n  def handle_event(\"close_all_dialogs\", _params, socket) do\n    # Send commands to multiple components\n    socket =\n      socket\n      |> SaladUI.LiveView.send_command(\"dialog-1\", \"close\")\n      |> SaladUI.LiveView.send_command(\"dialog-2\", \"close\")\n      |> SaladUI.LiveView.send_command(\"dialog-3\", \"close\")\n\n    {:noreply, socket}\n  end\nend\n```","ref":"component_communications_explain.html#1-using-saladui-liveview-send_command-4","title":"1. Using SaladUI.LiveView.send_command/4 - SaladUI Communication Guide","type":"extras"},{"doc":"Components handle commands in the `handleCommand()` method:\n\n```javascript\nclass ChartComponent extends Component {\n  handleCommand(command, params) {\n    switch (command) {\n      case \"update\":\n        this.updateChart(params.data, params.options);\n        return true;\n\n      case \"reset\":\n        this.resetChart();\n        return true;\n\n      case \"highlight\":\n        this.highlightDataPoint(params.index);\n        return true;\n\n      default:\n        return super.handleCommand(command, params);\n    }\n  }\n\n  updateChart(data, options = {}) {\n    this.chart.data = data;\n    if (options.animation) {\n      this.chart.update('active');\n    } else {\n      this.chart.update('none');\n    }\n  }\n}\n```","ref":"component_communications_explain.html#2-handling-commands-in-javascript","title":"2. Handling Commands in JavaScript - SaladUI Communication Guide","type":"extras"},{"doc":"Components can communicate directly with each other using JavaScript commands without server involvement.","ref":"component_communications_explain.html#client-client-communication","title":"Client → Client Communication - SaladUI Communication Guide","type":"extras"},{"doc":"Send commands directly between components using JavaScript actions in templates:\n\n```heex\n<!-- Button that opens a dialog -->\n<.button phx-click={SaladUI.JS.dispatch_command(\"open\", to: \"#user-dialog\")}>\n  Open Dialog\n</.button>\n\n<!-- Button that updates a chart -->\n<.button phx-click={SaladUI.JS.dispatch_command(\"update\",\n  to: \"#sales-chart\",\n  detail: %{data: @new_chart_data})}>\n  Refresh Chart\n</.button>\n\n<!-- Toggle multiple components -->\n<.button phx-click={\n  %JS{}\n  |> SaladUI.JS.dispatch_command(\"toggle\", to: \"#sidebar\")\n  |> SaladUI.JS.dispatch_command(\"close\", to: \"#dropdown\")\n}>\n  Toggle Layout\n</.button>\n```","ref":"component_communications_explain.html#using-saladui-js-dispatch_command-3","title":"Using SaladUI.JS.dispatch_command/3 - SaladUI Communication Guide","type":"extras"},{"doc":"When you use `SaladUI.JS.dispatch_command/3`, here's what happens:\n\n1. **JavaScript Generation**: The function generates JavaScript that dispatches a custom DOM event\n2. **Event Dispatch**: The browser fires a `salad_ui:command` event with the command details\n3. **Component Reception**: The target component automatically receives and processes the command\n4. **No Server Round-trip**: Everything happens in the browser without contacting the server","ref":"component_communications_explain.html#how-client-to-client-works","title":"How Client-to-Client Works - SaladUI Communication Guide","type":"extras"},{"doc":"```javascript\n// What SaladUI.JS.dispatch_command generates\ndocument.dispatchEvent(new CustomEvent('salad_ui:command', {\n  detail: {\n    command: 'open',\n    params: { data: newData },\n    target: 'user-dialog'\n  }\n}));\n\n// Components automatically listen for this event from both client and server\nclass Component {\n  setupEvents() {\n    document.addEventListener('salad_ui:command', (event) => {\n      const { command, params, target } = event.detail;\n\n      if (target === this.el.id) {\n        this.handleCommand(command, params);\n      }\n    });\n  }\n}\n```","ref":"component_communications_explain.html#under-the-hood","title":"Under the Hood - SaladUI Communication Guide","type":"extras"},{"doc":"You can pass data between components using the `detail` parameter:\n\n```heex\n<!-- Pass simple data -->\n<.button phx-click={SaladUI.JS.dispatch_command(\"highlight\",\n  to: \"#data-table\",\n  detail: %{row_id: @selected_row})}>\n  Highlight Row\n</.button>\n\n<!-- Pass complex data -->\n<.button phx-click={SaladUI.JS.dispatch_command(\"filter\",\n  to: \"#product-list\",\n  detail: %{\n    filters: %{\n      category: @category,\n      price_range: %{min: @min_price, max: @max_price},\n      in_stock: true\n    }\n  })}>\n  Apply Filters\n</.button>\n```","ref":"component_communications_explain.html#command-parameters","title":"Command Parameters - SaladUI Communication Guide","type":"extras"},{"doc":"Execute multiple commands in sequence:\n\n```heex\n<.button phx-click={\n  %JS{}\n  |> SaladUI.JS.dispatch_command(\"close\", to: \"#main-dialog\")\n  |> SaladUI.JS.dispatch_command(\"open\", to: \"#confirmation-dialog\")\n  |> SaladUI.JS.dispatch_command(\"focus\", to: \"#cancel-button\")\n}>\n  Show Confirmation\n</.button>\n```","ref":"component_communications_explain.html#chaining-commands","title":"Chaining Commands - SaladUI Communication Guide","type":"extras"},{"doc":"Components receive commands through their `handleCommand` method the same way it handle server command:\n\n```javascript\nclass DataTableComponent extends Component {\n  handleCommand(command, params) {\n    switch (command) {\n      case \"highlight\":\n        this.highlightRow(params.row_id);\n        return true;\n\n      case \"filter\":\n        this.applyFilters(params.filters);\n        return true;\n\n      case \"reset\":\n        this.clearFilters();\n        this.clearHighlight();\n        return true;\n\n      default:\n        return super.handleCommand(command, params);\n    }\n  }\n\n  highlightRow(rowId) {\n    // Remove previous highlights\n    this.el.querySelectorAll('.highlighted').forEach(row => {\n      row.classList.remove('highlighted');\n    });\n\n    // Highlight specific row\n    const targetRow = this.el.querySelector(`[data-row-id=\"${rowId}\"]`);\n    if (targetRow) {\n      targetRow.classList.add('highlighted');\n    }\n  }\n\n  applyFilters(filters) {\n    this.currentFilters = filters;\n    this.filterRows();\n    this.updateUI();\n  }\n}\n```","ref":"component_communications_explain.html#handling-commands-in-components","title":"Handling Commands in Components - SaladUI Communication Guide","type":"extras"},{"doc":"","ref":"component_communications_explain.html#communication-patterns-summary","title":"Communication Patterns Summary - SaladUI Communication Guide","type":"extras"},{"doc":"**Client → Server**:\n- User actions that need server processing\n- Form submissions and validation\n- Data persistence\n- Navigation changes\n- Real-time updates to other users\n\n**Server → Client**:\n- Update component state based on server events\n- Show/hide components based on permissions\n- Update data displays after server processing\n- Coordinate multiple components from server logic\n\n**Client → Client**:\n- Immediate UI feedback without server round-trip\n- Filter/search interactions\n- Component coordination and synchronization\n- Local state management","ref":"component_communications_explain.html#when-to-use-each-pattern","title":"When to Use Each Pattern - SaladUI Communication Guide","type":"extras"}],"producer":{"name":"ex_doc","version":[48,46,51,52,46,48]}}